<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Create proper working conditions in the camera  */

  var bAppStarted = isAppStarted("prodapp", "prod.syscalib.ecode");
  var bEnabled = bAppStarted;
	var strDisabled = "disabled ";
  var strStateName;
  var strPrompt;
  var nEcode = -1;
  
  if (bAppStarted)
  {
    strStateName = restree.getResourceValue("prod.syscalib.stateName");
    if ( strStateName == "Idle" )
    {
      restree.setResourceValue("prod.syscalib.command", "init");
      bEnabled = waitWhileBusy("prod.syscalib.status");
    }
    strPrompt = restree.getResourceValue("prod.syscalib.prompt");
    nEcode = restree.getResourceValue("prod.syscalib.ecode");
  }
	if ( bEnabled ) 
	  strDisabled = "";

  /* Dummy initiations of our form content variables  */
  var VersionSelector = new SelectTag("VersList", 1, strDisabled);
  var calVersion;
  var bBeingRecalibrated = false;
  var strOnSubmit;


  if (bEnabled)
  {
    /* Check that we have a legal strStateName  */
    
    /* Go through the submitted form , if it is our own one. */
    if ( Request.Form.Count > 0 && Request.Form( "SubmitSwitch" ) != "" ) 
    {
      restree.setResourceValue("prod.syscalib.version", Request.Form("VersList"));
	    restree.setResourceValue("prod.syscalib.command", "switch");

	    if ( !waitWhileBusy("prod.syscalib.status") )
	      nEcode = -1;
	    else
	    {
        nEcode = restree.getResourceValue("prod.syscalib.ecode");
        strPrompt = restree.getResourceValue("prod.syscalib.prompt");
	    }
	    
	    if ( nEcode == 0 )
	    {
        /* Submitted form OK, lets go to the next page. */
	    }
    }
	  /* Error in submitted form, or no submitted form */
   

    /* We are about to show our own form now. Fetch proper data for it */
	  restree.setResourceValue("prod.syscalib.command", "getVersions");
	  waitWhileBusy("prod.syscalib.status");

	  var strVersions = restree.getResourceValue("prod.syscalib.cmdargAct.versions");
	  var arrVersions = strVersions.split("\t");
	  
	  for ( var k = arrVersions.length-1; k >= 0; k-- )
	    VersionSelector.option( arrVersions[k], arrVersions[k], false);
	    
    calVersion = restree.getResourceValue( "calib.general.calibStage" );
    
    restree.path = "calib.extRBFCalc.recalData.cProt";
    var protCase = restree.getFirst();

    if (protCase != "")
    {
        bBeingRecalibrated = true;
        strOnSubmit = 'onSubmit="return AreYouSureAboutRecal();"';
    }
    else
        strOnSubmit = 'onSubmit="return AreYouSure();"';
    
    
  }
  var strTitle = "Switch calibration";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
<!--- Browser scripts --->
            <script>
            function AreYouSureAboutRecal()
            {
              return confirm("The camera is being recalibrated!!\nAre you sure you want to discard your work?");
            }
            function AreYouSure()
            {
              return confirm("Switching calibration!!\n     Are you sure?");
            }
            </script>
  <!--- End of browser scripts --->
    </head>
    <body id="pgCalibSysCalibActivate">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuCalib", "mnuCalibSysCalibSwitch" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE id="Table1">
                    <TR>
                        <TD vAlign="top">
                        <%
                          Response.Write("Current version: " + calVersion);
                        %>
                        </TD>
                    </TR>
                    <TR>
                        <TD vAlign="top">
                        <%
                          if ( bEnabled == false )
                              Response.Write("<span id=errstatus> Production Application not available! </span>");
                          else if ( nEcode == 0)
                          {
                            if (bBeingRecalibrated)
                              Response.Write("<span id=errstatus> The camera is being recalibrated! </span>");
                            
                          }
                          else
                              Response.Write("<span id=errstatus>" + strPrompt + "</span>");
                        %>
                        </TD>
                    </TR>
                    <TR>
                        <TD vAlign="top" width="250">
                            <FORM id="Form1" name="switchaction" action="#" method="post" <%Response.Write(strOnSubmit);%>>
                                New version: &nbsp;<%VersionSelector.print();%><br>
                                <BR>
                                <BR>
                                <INPUT id="Button1" type="submit" value="Switch" name="SubmitSwitch" <%if ( !bEnabled ) Response.Write("disabled");%>></INPUT>
                            </FORM>
                        </TD>
                    </TR>
                    <TR>
                        <TD vAlign="top">
                            (The previous calibration file is saved as calib_rsc.bak)
                        </TD>
                    </TR>
                </TABLE>
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
