<%@  language="JSCRIPT" %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
//<!-- #include virtual = "/service/inc/eepromlock.inc" -->
<%
  /* Server side scripts */
    
var WarmWith = 0.0;
var ColdWith = 0.0;
var WarmWithout = 0.0;
var ColdWithout = 0.0;
var Transmission = 0.0;
var winWidth = 640;
var winHeight = 480;
var ErrorText = "";
var restreeLens = new ResTree();
var Lens = "?";
var Serial = "?";

function Restore()
{
	/* Restore image, clear values */
	restree.setResourceValue( ".tcomp.active", true );
	restree.setResourceValue( ".image.flow.maps.combGainDeadMap.active", true );
	restree.setResourceValue( ".image.flow.maps.combOffsetMap.active", true );
	restree.setResourceValue( ".image.flow.maps.shutterMap.active", true );
	restree.setResourceValue( ".image.contadj.active", true );
	restree.setResourceValue( ".image.services.nuc.true", true );
}

function RawImage() {
	ImageWidth = restree.getResourceValue( ".image.framegrab.ir.geom.width" );
	ImageHeight = restree.getResourceValue( ".image.framegrab.ir.geom.height" );
	restree.setResourceValue( ".image.sysimg.measureFuncs.mbox.1.x", ImageWidth / 2 - 8  );
	restree.setResourceValue( ".image.sysimg.measureFuncs.mbox.1.y", ImageHeight / 2 - 8  );
	restree.setResourceValue( ".image.sysimg.measureFuncs.mbox.1.width", 16  );
	restree.setResourceValue( ".image.sysimg.measureFuncs.mbox.1.height", 16  );
	restree.setResourceValue( ".image.sysimg.measureFuncs.mbox.1.active", true );
	restree.setResourceValue( ".image.measure.mode", "NORMAL" );

	// Set camera for raw images
	restree.setResourceValue( ".tcomp.active", false );
	restree.setResourceValue( ".image.flow.maps.combGainDeadMap.active", false );
	restree.setResourceValue( ".image.flow.maps.combOffsetMap.active", false );
	restree.setResourceValue( ".image.flow.maps.shutterMap.active", false );
	restree.setResourceValue( ".image.flow.globalCorr.GG", 1.0 );
	restree.setResourceValue( ".image.flow.globalCorr.L", 0 );
	restree.setResourceValue( ".image.flow.globalCorr.M", 0 );
	restree.setResourceValue( ".image.contadj.active", true );
	
	restree.sleep( 2000 );
}

function Clear()
{
	WarmWith = 0.0;
	ColdWith = 0.0;
	WarmWithout = 0.0;
	ColdWithout = 0.0;
	Transmission = 0.0;
	restree.setResourceValue( ".prod.map.arg1", 0 );
	restree.setResourceValue( ".prod.map.arg2", 0 );
	restree.setResourceValue( ".prod.map.arg3", 0 );
	restree.setResourceValue( ".prod.map.arg4", 0 );
}
			
function Calculate()
{
	ErrorText = "";
	if( ColdWithout == 0 || WarmWithout == 0 || WarmWith == 0 || ColdWith == 0 ) {
		ErrorText = "<span id=errstatus>Missing (a) mesurement(s)";
	}
	else {
		/* tauFOL23 = (rawBB50FOL23 - rawBB30FOL23)/(rawBB50 - rawBB30) */
		Transmission = 0;
		if(( WarmWithout - ColdWithout ) != 0 )
			Transmission = ( WarmWith - ColdWith ) / ( WarmWithout - ColdWithout );
			Transmission = Transmission.toFixed(3)
			if( Transmission < 0.74 || Transmission > 0.94 ) {
			ErrorText = "<span id=errstatus>Transmission out of spec";
		}
	}
}

function Init()
{
	if ( restreeLens.valueType( "image.flow.lensExt.lensConnected") == "bool" ) { // E camera with external lens
		if ( restreeLens.getResourceValue("image.flow.lensExt.lensConnected") == true )
		   restreeLens.path = "image.flow.lensExt";
		else {
		   restreeLens.path = "image.flow.lensInt";
		   ErrText = "Update of lens transmission not available in this camera";
		   return;
	   }
	}
	else
		restreeLens.path = "image.flow.lens";
		
	Serial = restreeLens.getResourceValue( "SN" );			
	Lens = restreeLens.getResourceValue( "descr" );			

	return;
}

function Measure()
{
	var ii;
	var i;
	var MCnt;
	var MValue;
	
	for( ii = 0; ii <= 10; ii++ ) {
		// Just a check that we still are in raw image mode
		if( restree.getResourceValue( ".image.flow.globalCorr.M" ) != 0 || restree.getResourceValue( ".image.flow.globalCorr.L" ) != 0 )
			RawImage();

		MCount = restree.getResourceValue( ".image.measure.count" );
		MCnt = 0
		MValue = 0
		for( i = 0; i < 50; i++ ) {
			var MCount2 = restree.getResourceValue( ".image.measure.count" );
			if( MCount2 > MCount ) {
				MCount = MCount2;
				MValue += restree.getResourceValue( ".image.sysimg.measureFuncs.mbox.1.medianS" );
				MCnt++;
				if( MCnt >= 5 ) {
					MValue /= 5;
					break;
				}
			}
			else {
				restree.sleep( 200 );
			}
		}
		if( i == 50 ) {
			ErrText = "Measurement failed"
			return 0;	
		}
		
		// Just a check that we still are in raw image mode
		if( restree.getResourceValue( ".image.flow.globalCorr.M" ) != 0 || restree.getResourceValue( ".image.flow.globalCorr.L" ) != 0 ) {
			continue;		//  Sigh..... try again
		}
		return MValue.toFixed(0);
	}	
	ErrText = "Failed to set raw image";	// wtf.... still not raw image
	return 0;
}

/*********************************************************
* Execute a prodapp.syscalib command.
*********************************************************/

function executeCommand( cmd )
{
	var retCode;

	restree.setResourceValue("prod.syscalib.command", cmd);
	if ( !waitWhileBusy("prod.syscalib.status") )
	{
		retCode = -1;
	}
	else
	{
		retCode = restree.getResourceValue("prod.syscalib.ecode");
	}
	return retCode;
}

/*********************************************************
* Start of main code body.
*********************************************************/

/* Start the production application, unless already done */

var started = false;

var ready = restree.getResourceValue( "prod.log.status" );
if( ready != "ready" )
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );

for( i = 0; i < 1000; i++ ) 
{
	ready = restree.getResourceValue( "prod.log.status" );
	if( ready == "ready") 
	{
		started = true;
		break;
	}
	restree.sleep( 200 );
}

if( !started ) {
	ErrText = "Production Application not available!";
}

else {
	Init()

	ColdWithout = restree.getResourceValue( ".prod.map.arg1" );
	WarmWithout = restree.getResourceValue( ".prod.map.arg2" );
	WarmWith = restree.getResourceValue( ".prod.map.arg3" );
	ColdWith = restree.getResourceValue( ".prod.map.arg4" );
		
	/*
	* Any form data ?
	* No form data indicates a window refresh.
	*/
	if ( Request.Form.Count > 0 ) {
		/*
		* Decode the command.
		*/
			
		if( Request.Form( "ColdWithout" ) != "" )	{
			ColdWithout = Measure();
			restree.setResourceValue( ".prod.map.arg1", ColdWithout );
		}
		else if( Request.Form( "WarmWithout" ) != "" )	{
			WarmWithout = Measure();
			restree.setResourceValue( ".prod.map.arg2", WarmWithout );
		}
		else if( Request.Form( "WarmWith" ) != "" )	{
			WarmWith = Measure();
			restree.setResourceValue( ".prod.map.arg3", WarmWith );
		}
		else if( Request.Form( "ColdWith" ) != "" )	{
			ColdWith = Measure();
			restree.setResourceValue( ".prod.map.arg4", ColdWith );
		}
		else if( Request.Form( "Calculate" ) != "" ) {
			Calculate();
		}
		else if ( Request.Form( "Save" ) != "" ) {
			Calculate();
	
			// Check lens is mounted
			if( !restreeLens.getResourceValue( "lensConnected" )) {			
				ErrorText = "<span id=errstatus> Lens not mounted";
			}
			
			if( ErrorText == "" ) {
				var ValueType = restreeLens.valueType( "refTTransmission" );
				if( ValueType != "float" ) {
					ErrorText = "<span id=errstatus>Update of lens transmission not available";
				}
				else {
					restreeLens.setResourceValue( "refTTransmission", Transmission );
					restreeLens.setResourceValueWait( "updateLens", 1 );
					ErrorText = "<span id=OKstatus>Lens data updated";
				}
			}
			Restore();
		}
		else if ( Request.Form( "Restore" ) != "" ) {		
			Restore();
			Clear();
		}
	}
	else {
		RawImage();
		Clear();
	}
}

var strTitle = "Calibrate lens transmission. Lens: " + Lens + " s/n :" + Serial; 
  
%>
<html>
<head>
  <title>
    <%Response.Write(strTitle + " - " + CamFamily + " Service Web");%>
  </title>
  <link href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
 
  <style type="text/css">
        #imgBmpClipDiv {
          position: absolute;
          left: auto; top: auto;
          height: auto;
          width: auto;
          overflow: hidden;
          z-index: 1;
        }
      </style>
</head>
<body id="pgTransmission" onload="initPage()">
  <%printStandardDecoration( strTitle );%>
  <%printNavigation( "mnuCalib", "mnuCalibTransM" );%>
  <!-- This is the actual contents -->
  <div id="mainpane">
    <div id="content">
      <table width="<%Response.Write( winWidth + 500 );%>">
        <tr>
		<td valign="top">
This application will measure and update the lens transmission value of the measured lens using a camera.<br>
The application is only valid for cameras with removable lens and is mainly intended for GF cameras with dewar. 
The lens transmission value is necessary for optimization calculations of the radiometric maps. 
The lens transmission value is considered to be constant for the GF applicable wavelengths.<BR>
All measurements are done using "raw" images. It is recommended to restore image before leaving the page<BR>
The measurements are not dependent of the individual IDCA for a GF model. 
Since the different GF models have different sub range coverage it may not be possible to have the same set of black bodies. 
The selection of the two black body temperatures should be one at the upper temperature range, "warm BB", and one at the lower part of the range, "cold BB".  
For instance for a GF 320 the appropriate selection of sub range would be 10-60C e.g. black body temperatures of 30 and 50C would work fine.<br> 
For best result, allow 15min warm up, with lens on, before measurements.
Be aware: It is very important to center the camera and keep as close as possible to the black body 
 especially when pointing with a naked dewar without a lens on.<BR> 
The steps are as follows:<BR>
	Measure against cold black body with lens.<BR>
	Measure againts warm black body with lens.<BR>
	Measure against cold black body without the lens attached (transmission through dewar only).<BR>
	Measure against warm black body without the lens attached (transmission through dewar only).<BR>
	Calculate transmission.<BR>
   Save new transmission in lens.<BR>
Transmission outside the expected range of 0.74 to 0.94 is not acceptable.

       </td>
        </tr>
      </table>
      <table id="Table2" width="300" CELLSPACING = 10>
        <tr>
			<form action="#" method="post" name="imagehandling" id="imagehandling" onsubmit="return onSubmitFunc();">
				<tr>
					<TD><input type="submit" value="Cold BB With lens" id="ColdWith" name="ColdWith">
					<TD><%Response.Write( ColdWith );%>
				</tr>
				<tr>
					<TD><input type="submit" value="Warm BB with lens" id="WarmWith" name="WarmWith">
					<TD><%Response.Write( WarmWith );%>
				</tr>
				<tr>
					<TD><input type="submit" value="Cold BB without lens" id="ColdWithout" name="ColdWithout">
					<TD><%Response.Write( ColdWithout );%>
				</tr>
				<tr>
					<TD><input type="submit" value="Warm BB without lens" id="WarmWithout" name="WarmWithout">
					<TD><%Response.Write( WarmWithout );%>
				</tr>
				<tr>
					<TD><input type="submit" value="Calculate transmission" id="Calculate" name="Calculate">
					<TD><%Response.Write( Transmission );%>
				</tr>
				<tr>
					<TD><input type="submit" value="Save in lens" id="Save" name="Save">
				</tr>
				<tr>
                    <TD><input type="submit" value="Restore Image" id="Restore" name="Restore">
				</tr>
				<%Response.Write( "<b>" + ErrorText + "</b>" );%><BR><BR>
			</form>
      </table>
    </div>
    <%printStandardFooter();%>
  </div>
  <!-- End of actual contents -->
</body>
</html>
