<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<%
    var strTitle = "Built-in Test";

    /*
     * Evaluate which tests to perform.
     */
    var testEEprom = true;
    var testShutter = true;
    if ( CamType == "PREM" || CamType == "G" )
      testShutter = false;

    var testTempsens = true;
    if ( CamType == "PREM" )
      testTempsens = false;

    var testButtons = true;
    if ( CamType == "A" || CamType == "A2" )
      testButtons = false;

    var testBattery = true;
    if ( CamType == "A" || CamType == "Z" || CamType == "A2" || CamType == "Z3" )
      testBattery = false;

    var testAperture = true;
    if ( CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "PREM" || CamType == "G" || CamType == "Z3" )
      testAperture = false;

    var testFilter = false;
    if ( CamType == "P" || CamType == "G"  )
      testFilter = true;

    var testClock = true;
    if ( CamType == "Z" )
      testClock = false;

    var testFocus = true;
    if ( CamType == "X" || CamType == "X2" || CamType == "Z" || CamType == "PREM" || CamType == "Z3" )
      testFocus = false;

    var testLaser = true;
    if ( CamType == "A" || CamType == "Z" || CamType == "PREM" || CamType == "A2" || CamType == "Z3" )
      testLaser = false;

    var testLCD = true;
    if ( CamType == "A" || CamType == "A2" )
      testLCD = false;

    var testGPS = false;
    if ( CamType == "P" || CamType == "Pt" || CamType == "G" )
      testGPS = true;

    var testVF = false;
    if ( CamType == "P" || CamType == "Pt" || CamType == "G" )
      testVF = true;

	var testTouchscreen = false;
    if ( CamType == "E3" )
      testTouchscreen = true;

%>
<HTML>
    <HEAD>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    </HEAD>
    <body id="pgDiagBIT">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuDiag", "mnuDiagBIT" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE ID="Table1">
                    <TR>
                        <TD VALIGN="top">
                            <h2>Instruction</h2>
                            Built-in tests are usually made with an assembled camera.<br>
                            Some of the tests require manual intervention, (the "Interactive tests") and 
                            others not (the "Self tests").<br>
                            <br>
                            To run the tests:<br>
<% if ( testBattery )
            Response.Write("- Insert a battery and connect if possible to external power.<BR>");%>
                            - Connect the Camera to a PC via the USB port by ThermaCam QuickView, or 
                            similar.<BR>
                            - Start with the Self tests and then continue with the Interactive tests.<br>
                            <br>
                            <br>
                            There is an error status indicator, common to all built-in tests, which will 
                            display the current number of failures.<br>
                            If a particular test first fails and then succeeds, this status will first 
                            increase and then decrease.<br>
                            <BR>
                            <BR>
                            <u>Self Tests</u><br>
                            <br>
<% if ( testBattery )
            Response.Write("The Battery test will try to detect the battery via I2C.<br><br>");%>
<% if ( testClock )
            Response.Write("The Clock test will read the clock twice and check that the correct time has elapsed.<br><br>");%>
<% if ( testEEprom )
            Response.Write("The EEProm test will try to detect the EEProm(s) via I2C.<br><br>");%>
<% if ( testTempsens )
            Response.Write("The Temp Sensor test will try to read the temperature sensors via I2C.<br><br>");%>
<% if ( testFocus )
            Response.Write("The Focus test will exercise the Focus motor.<br><br>"); %>
<% if ( testGPS )
            Response.Write("The GPS test checks that the GPS unit exists and seems OK.<br><br>"); %>

                            <u>Interactive Tests</u><br>
                            <br>
<% if ( testButtons )
            Response.Write("The Buttons test will let the tester press all buttons (except laser) within 20 s.<br><br>");%>

<% if ( testShutter ) {
     if ( CamType == "P" || CamType == "X" )
            Response.Write("The Shutter test will activate/deactivate the shutter three times.<br><br>");
     if ( CamType == "E" || CamType == "A" || CamType == "Z" || CamType == "X2" || CamType == "A2" || CamType == "E2" || CamType == "Pt" || CamType == "E3" || CamType == "FX" || CamType == "Z3" )
            Response.Write("The Shutter test will activate/deactivate the shutter three times. Aim the camera against a 100 C blackbody.<br><br>");
}
%>
<% if ( testAperture )
            Response.Write("The Aperture test will activate/deactivate the aperture three times. If Ylva E3: Aim the camera against a 100 C blackbody.<br><br>");%>
<% if ( testFilter )
            Response.Write("The Filter test will activate/deactivate the filter three times.<br><br>");%>
<% if ( testLaser )
            Response.Write("The Laser test will let the tester press the laser button within 5 s.<br><br>");%>
<% if ( testLCD )
            Response.Write("The LCD test will show some test patterns.<br><br>");%>
<% if ( testVF )
            Response.Write("The viewfinder test will show some test patterns.<br><br>");%>
			
<% if ( testTouchscreen )
            Response.Write("The Touchscreen test will let the tester press touchscreen at 9 position within 20 s.<br><br>");%>
			
                            <u>Popular error codes</u><br>
                            <br>
<% if ( testBattery )
            Response.Write("E 0002 = BATTERY NOT DETECTED<br>");%>
<% if ( testClock ) {
            Response.Write("E 0011 = CLOCK NOT DETECTED<br>");
            Response.Write("E 0012 = CLOCK NOT RUNNING<br>");
} %>
<% if ( testEEprom )
            Response.Write("E 0021 = EEPROM NOT DETECTED<br>");%>
<% if ( testTempsens ) {
            Response.Write("E 0031 = TEMPERATURE SENSOR NOT DETECTED<br>");
            Response.Write("E 0032 = TEMPERATURE OUT OF RANGE<br>");
} %>
<% if ( testLaser )
            Response.Write("E 0041 = LASER NOT DETECTED<br>");%>
<% if ( testFocus ) {
     Response.Write("E 00A1 = FOCUS MOTOR NOT DETECTED<br>");
     if ( CamType == "P" || CamType == "Pt" || CamType == "E" ) {
            Response.Write("E 00A2 = FOCUS FAR NOT REACHED<br>");
            Response.Write("E 00A3 = FOCUS NEAR NOT REACHED<br>");
     }
} %>
<% if ( testShutter ) {
            Response.Write("E 0074 = SHUTTER STUCK<br>");
            Response.Write("E 0075 = SHUTTER LOCKED<br>");
} %>
                            <br>
                            More information about the errors is available in the test log.<br>
                        </TD>
                    </TR>
                </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</HTML>
