    <%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
    /* Server side scripts */
    
  var irNearFile = "/images/noimage.jpg";
  var irFarFile = "/images/noimage.jpg";
  var visNearFile = "/images/noimage.jpg";
  var visFarFile = "/images/noimage.jpg";

  /*********************************************************
  * Create a new jpeg ir image on the ram disk.
  *********************************************************/
  function getNewIr( filename )
  {
    restree.setResourceValue( "image.services.store.bgActive", false );
    restree.setResourceValue( "image.services.channel.active", "IR" );
    restree.setResourceValue( "image.services.channel.commit", true );

    var cnt = 500;
    restree.sleep( 200 );
    while (restree.getResourceValue( "image.services.channel.status" ) != 0 && cnt-- > 0 )
        restree.sleep( 200 );
    
    restree.setResourceValue( "image.services.store.overlay", false );
    restree.setResourceValue( "image.services.store.usePogo", false );
    restree.setResourceValue( "image.services.store.format", "JPEG_no_IR" );
    restree.setResourceValue( "image.services.store.format", "JPEG" );
    restree.setResourceValue( "image.services.store.overwrite", true );
    restree.setResourceValue( "image.services.store.quality", 85 );
    restree.setResourceValue( "image.services.store.filename", filename );
    restree.setResourceValueWait( "image.services.store.commit", true );
    cnt = 100;
    while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
        restree.sleep( 200 );
  }

  /*********************************************************
  * Create a new jpeg visual image on the ram disk.
  *********************************************************/
  function getNewVisual( filename )
  {
    restree.setResourceValue( "system.vcam.active", true );
    restree.setResourceValue( "image.services.channel.active", "VISUAL" );
    restree.setResourceValue( "image.services.channel.commit", true );

    var cnt = 500;
    restree.sleep( 200 );
    while (restree.getResourceValue( "image.services.channel.status" ) != 0 && cnt-- > 0 )
        restree.sleep( 200 );

    restree.setResourceValue( "image.services.store.format", "JPEG_visual" );
    restree.setResourceValue( "image.services.store.overlay", false );
    restree.setResourceValue( "image.services.store.overwrite", true );
    restree.setResourceValue( "image.services.store.quality", 75 );
    restree.setResourceValue( "image.services.store.filename", filename );
    restree.setResourceValueWait( "image.services.store.commit", true );
    cnt = 100;
    while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
        restree.sleep( 200 );
  }

  /*********************************************************
  * Create a new ir image.
  *********************************************************/
  function getNewIrImage( distance )
  {
    var irFile = "/Temp/" + distance + "Ir.jpg";
    var RandomVal = Math.random();

    RandomString = new String( RandomVal.toString( 16 ) );
    getNewIr( irFile );
    if( distance == "Near" || distance == "near" )
    {
      irNearFile = "/Ram/NearIr.jpg" + "?" + RandomString;
      focusNear = restree.getResourceValue( "system.focus.position" );
    }
    else
    {
      irFarFile = "/Ram/FarIr.jpg" + "?" + RandomString;
      focusFar = restree.getResourceValue( "system.focus.position" );
    }
  }

  /*********************************************************
  * Create a new visual image.
  *********************************************************/
  function getNewVisualImage( distance )
  {
    var visFile = "/Temp/" + distance + "Vis.jpg";
    var RandomVal = Math.random();

    RandomString = new String( RandomVal.toString( 16 ) );
    getNewVisual( visFile );
    if( distance == "Near" || distance == "near" )
      visNearFile = "/Ram/NearVis.jpg?" + RandomString;
    else
      visFarFile = "/Ram/FarVis.jpg?" + RandomString;
  }

  /*********************************************************
  * Create a matched pair of ir/visual images.
  *********************************************************/
  function getNewImages( distance )
  {
	  if( CamType == "X2" ) {
		   restree.setResourceValue( ".prod.syscalib.cmdargAlign.showFocus", false );
	  }
    getNewIrImage( distance );
    getNewVisualImage( distance );
    restree.setResourceValue( "image.services.channel.active", "IR" );
    restree.setResourceValue( "image.services.channel.commit", true );
  }

  /*********************************************************
  * Start of main code body.
  *********************************************************/

  /* Start the production application, unless already done */
  var started = false;
      
  var ValueType = restree.valueType( "prod.syscalib.status" );
  if( ValueType != "N/A") /* This works on all types of values */
  { 
    started = true;
  }
        
  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  "prodapp" );
    for( i = 0; i < 1000; i++ ) 
    {
      var ValueType = restree.valueType( "prod.syscalib.status" );
      if( ValueType != "N/A") 
      {
        started = true;
        break;
      }
      restree.sleep( 200 );
    }
  }

  var ECode = -1;
  var currentAction = "";
  var strPrompt = "";
  /*
   * Read frame grabber selection from prodspec and set visual scaling defaults.
   */
  var visualFramegrabber = restree.getResourceValue( "prod.prodSpec.calib.config.fusion.visFramegrabber" );
  var rescaleVisual = false;
  var visualScale = new Number( 1.0 );   // Scale factor when reporting visual coordinates.
                                         // Used when a P640MkII wants coordinates from a 640x480 visual image.
  /*
   * Read width and height of IR and visual images.
   */
  var detectorWidth = restree.getResourceValue( "image.framegrab.ir.geom.width" );
  var detectorHeight = restree.getResourceValue( "image.framegrab.ir.geom.height" );
  var visualWidth = restree.getResourceValue( "image.framegrab.visualbig.geom.width" );
  var visualHeight = restree.getResourceValue( "image.framegrab.visualbig.geom.height" );
  var bmpWidthIR;
  var bmpHeightIR;
  var bmpWidthVisual;
  var bmpHeightVisual;
  var winWidth;
  var winHeight;
  var ratioBmpToIR;
  var ratioBmpToVisual;
  var IEoffset = 0;
  /*
   * Other default values.
   */
  var distNear = 0.5;
  var distFar = 2.5;
  var focusNear = 0;
  var focusFar = 0;
  var magNear = 0;
  var rotNear = 0;
  var magFar = 0;
  var rotFar = 0;
  var num = new Number;
  var bInitError = false; 
  var bNearError = false; 
  var bFarError = false; 
  var bStoreError = false; 
  var imgSelect = "irNear";
  var distMode = "Near";
  var imgMode = "Ir";
  var ErrorPhase = "Unknown";
  var C2 = 0;
  var C3 = 0;
  var strSkipFocusCheck = "";
  /*
   * P-cam has a detector with 640x480 pixels.
   * P-cam (P640MkII) visual camera with 2048x1536 pixels.
   * E-cam has a detector with 320x240 pixels.
   * E-cam visual camera with is 1280x960 pixels.
   * X2-cam has a detector with 180x180 pixels.
   * X2-cam visual camera with 1536x1536 pixels.
   */
  if( CamType == "E" || CamType == "E2" || CamType == "Z3" )
  {
    /*
     * Turn graphics off using the Gui on an E-camera.
     */
    if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
      restree.setResourceValue( "gui.system.hideGraphics", true );

    winWidth = 640; 
    winHeight = 480;

    ratioBmpToIR = 2;
    bmpWidthIR = new Number( detectorWidth * ratioBmpToIR );
    bmpHeightIR = new Number( detectorHeight * ratioBmpToIR );
    bmpWidthIR = bmpWidthIR.toFixed( 0 );
    bmpHeightIR = bmpHeightIR.toFixed( 0 );
    IEoffset = 0;         // Compensation to use with Internet Explorer.

		ratioBmpToVisual = 1280 / visualWidth;
//    ratioBmpToVisual = 1;
    bmpWidthVisual = new Number( visualWidth * ratioBmpToVisual );
    bmpHeightVisual = new Number( visualHeight * ratioBmpToVisual );
    bmpWidthVisual = bmpWidthVisual.toFixed( 0 );
    bmpHeightVisual = bmpHeightVisual.toFixed( 0 );
    // Check if the prodapp expects the visual coordinates from a 640x480 image.
    if( visualFramegrabber == "visual" )
    {

      rescaleVisual = true;
//      visualScale = new Number( visualWidth / 640 );
			visualScale =  new Number( visualWidth / restree.getResourceValue( ".image.framegrab.visual.geom.width" ));
    }
  }
  else if( CamType == "P" || CamType == "Pt" || CamType == "G" )
  {
    /*
     * Turn graphics off using the Gui on a P-camera.
     */
    if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
      restree.setResourceValue( "gui.system.hideGraphics", true );

    winWidth = 640;
    winHeight = 480;

    ratioBmpToIR = 1;
    bmpWidthIR = new Number( detectorWidth * ratioBmpToIR );
    bmpHeightIR = new Number( detectorHeight * ratioBmpToIR );
    bmpWidthIR = bmpWidthIR.toFixed( 0 );
    bmpHeightIR = bmpHeightIR.toFixed( 0 );
    IEoffset = 0;      // Compensation to use with Internet Explorer.

    ratioBmpToVisual = 1;

    bmpWidthVisual = new Number( visualWidth * ratioBmpToVisual );
    bmpHeightVisual = new Number( visualHeight * ratioBmpToVisual );
    bmpWidthVisual = bmpWidthVisual.toFixed( 0 );
    bmpHeightVisual = bmpHeightVisual.toFixed( 0 );
    // Check if the prodapp expects the visual coordinates from a 640x480 image.
    if( visualFramegrabber == "visual" )
    {
      rescaleVisual = true;
      visualScale = new Number( visualWidth /640 );
    }
  }
  else if( CamType == "X2" )
  {
    /*
     * Turn graphics off using the Gui on a X2-camera.
     */
    if( !restree.getResourceValue( "gui.system.hideGraphics" ) )
      restree.setResourceValue( "gui.system.hideGraphics", true );

    winWidth = 480;
    winHeight = 480;

    ratioBmpToIR = 2.6667;
    bmpWidthIR = new Number( detectorWidth * ratioBmpToIR );
    bmpHeightIR = new Number( detectorHeight * ratioBmpToIR );
    bmpWidthIR = bmpWidthIR.toFixed( 0 );
    bmpHeightIR = bmpHeightIR.toFixed( 0 );
    IEoffset = 0;      // Compensation to use with Internet Explorer.

    ratioBmpToVisual = 0.5;		/* Adjusted for fov diffrereces */

    bmpWidthVisual = new Number( visualWidth * ratioBmpToVisual );
    bmpHeightVisual = new Number( visualHeight * ratioBmpToVisual );
    bmpWidthVisual = bmpWidthVisual.toFixed( 0 );
    bmpHeightVisual = bmpHeightVisual.toFixed( 0 );
    // Check if the prodapp expects the visual coordinates from a 480x480 image.
    if( visualFramegrabber == "visual" )
    {
      rescaleVisual = true;
      visualScale = new Number( visualWidth / 480 );
    }
  }
  else
  {
    Response.Redirect( "/Service/Focus/" );
  }

   var  xRes = restree.getResourceValue( "image.framegrab.ir.geom.width" );

  /*
   * Calculate suitable initial haircross positions and visual image offsets
   */
  var irNearX0 = new Number( detectorWidth / 3 );
  var irNearY0 = new Number( detectorHeight / 3 );
  var irNearX1 = new Number( detectorWidth * 2 / 3 );
  var irNearY1 = new Number( detectorHeight / 3 );
  var irNearX2 = new Number( detectorWidth / 2 );
  var irNearY2 = new Number( detectorHeight * 2 / 3 );

  var visNearX0 = new Number( bmpWidthVisual / 2 - 107 );
  var visNearY0 = new Number( bmpHeightVisual / 2 - 80 );
  var visNearX1 = new Number( bmpWidthVisual / 2 + 107 );
  var visNearY1 = new Number( bmpHeightVisual / 2 - 80 );
  var visNearX2 = new Number( bmpWidthVisual / 2 );
  var visNearY2 = new Number( bmpHeightVisual / 2 + 80 );

  irNearX0 = irNearX0.toFixed( 0 );
  irNearY0 = irNearY0.toFixed( 0 );
  irNearX1 = irNearX1.toFixed( 0 );
  irNearY1 = irNearY1.toFixed( 0 );
  irNearX2 = irNearX2.toFixed( 0 );
  irNearY2 = irNearY2.toFixed( 0 );
  visNearX0 = visNearX0.toFixed( 0 );
  visNearY0 = visNearY0.toFixed( 0 );
  visNearX1 = visNearX1.toFixed( 0 );
  visNearY1 = visNearY1.toFixed( 0 );
  visNearX2 = visNearX2.toFixed( 0 );
  visNearY2 = visNearY2.toFixed( 0 );
  var irFarX0 = new Number( irNearX0 );
  var irFarY0 = new Number( irNearY0 );
  var irFarX1 = new Number( irNearX1 );
  var irFarY1 = new Number( irNearY1 );
  var irFarX2 = new Number( irNearX2 );
  var irFarY2 = new Number( irNearY2 );
  var visFarX0 = new Number( visNearX0 );
  var visFarY0 = new Number( visNearY0 );
  var visFarX1 = new Number( visNearX1 );
  var visFarY1 = new Number( visNearY1 );
  var visFarX2 = new Number( visNearX2 );
  var visFarY2 = new Number( visNearY2 );
  var offNearX = new Number( bmpWidthVisual / 2 - 320 );
  var offNearY = new Number( bmpHeightVisual / 2 - 240 );
  var offFarX = new Number( bmpWidthVisual / 2 - 320 );
  var offFarY = new Number( bmpHeightVisual / 2 - 240 );
  offNearX = offNearX.toFixed( 0 );
  offNearY = offNearY.toFixed( 0 );
  offFarX = offFarX.toFixed( 0 );
  offFarY = offFarY.toFixed( 0 );
  /*
   * Adjust haircross positions and visual image offsets
   * to compensate for visual camera parallax error.
   */
  if( CamType == "E"  || CamType == "E2" )
  {
    // Compensate for a visual camera mounted on a horizontal offset
    offNearX = new Number( bmpWidthVisual / 2 - 480 );
    visNearX0 = new Number( bmpWidthVisual * visualScale / 2 - 240 );
    visNearX1 = new Number( bmpWidthVisual * visualScale / 2 - 40 );
    visNearX2 = new Number( bmpWidthVisual * visualScale / 2 - 150 );
  }
  else if( CamType == "P" || CamType == "Pt" || CamType == "G" )
  {
    // Compensate for a visual camera mounted on a vertical offset
    offNearY = new Number( bmpHeightVisual / 2 + 60 );
    visNearY0 = new Number( bmpHeightVisual / 2 + 220 );
    visNearY1 = new Number( bmpHeightVisual / 2 + 220 );
    visNearY2 = new Number( bmpHeightVisual / 2 + 380 );
  }
  else if( CamType == "X2" )
  {
    // Seems like we have a scale factor of *2 here
    // Compensate for a visual camera mounted on a vertical offset
    offNearX = 128;
    offNearY = 165;
    offFarX = 128;
    offFarY = 128;

    visNearX0 = visFarX0 = 600;
    visNearY0 = visFarY0 = 650;

    visNearX1 = visFarX1 = 900;
    visNearY1 = visFarY1 = 650;

    visNearX2 = visFarX2 = 768;
    visNearY2 = visFarY2 = 950;
 
  }
  /*
   * Check that we managed to start the production application program.
   */
  if( started )
  {
    ECode = 0;
    /*
     * Any form data ?
     * No form data indicates a window refresh.
     */
    if ( Request.Form.Count <= 0 ) {
		// Start by executing a "alignInit" command
		restree.setResourceValue("prod.syscalib.command", "alignInit");
		if ( !waitWhileBusy("prod.syscalib.status") )
		{
			bInitError = true;
			ECode = -1;
			ErrorPhase = "Initialise";
		}
		else {
			if( !restree.getResourceValue(".prod.log.serviceMode")) {
				ECode  = 1;
				bInitError = true;
				ErrorPhase = "Initialise";
				strPrompt = "Not in service mode";
			}
		}
	}
	if( ECode == 0 ) {
      /*
       * Extract image mode from URL
       * (near IR, far IR, near Visual or far Visual).
       */
      if ( Request.Form("imgSelect") != "" ) {
        imgSelect = Request.Form("imgSelect");
        if( imgSelect == "irNear" || imgSelect == "visNear" )
          distMode = "Near";
        else
          distMode = "Far";

        if( imgSelect == "irNear" || imgSelect == "irFar" )
          imgMode = "Ir";
        else
          imgMode = "Visual";
      }
      /*
       * Extract haircross positions and visual image offsets from URL
       */
      if ( Request.Form("irNearX0") != "" ) {
        irNearX0 = Request.Form("irNearX0");
      }
      if ( Request.Form("irNearY0") != "" ) {
        irNearY0 = Request.Form("irNearY0");
      }
      if ( Request.Form("irNearX1") != "" ) {
        irNearX1 = Request.Form("irNearX1");
      }
      if ( Request.Form("irNearY1") != "" ) {
        irNearY1 = Request.Form("irNearY1");
      }
      if ( Request.Form("irNearX2") != "" ) {
        irNearX2 = Request.Form("irNearX2");
      }
      if ( Request.Form("irNearY2") != "" ) {
        irNearY2 = Request.Form("irNearY2");
      }
      if ( Request.Form("visNearX0") != "" ) {
        visNearX0 = Request.Form("visNearX0");
      }
      if ( Request.Form("visNearY0") != "" ) {
        visNearY0 = Request.Form("visNearY0");
      }
      if ( Request.Form("visNearX1") != "" ) {
        visNearX1 = Request.Form("visNearX1");
      }
      if ( Request.Form("visNearY1") != "" ) {
        visNearY1 = Request.Form("visNearY1");
      }
      if ( Request.Form("visNearX2") != "" ) {
        visNearX2 = Request.Form("visNearX2");
      }
      if ( Request.Form("visNearY2") != "" ) {
        visNearY2 = Request.Form("visNearY2");
      }
      if ( Request.Form("irFarX0") != "" ) {
        irFarX0 = Request.Form("irFarX0");
      }
      if ( Request.Form("irFarY0") != "" ) {
        irFarY0 = Request.Form("irFarY0");
      }
      if ( Request.Form("irFarX1") != "" ) {
        irFarX1 = Request.Form("irFarX1");
      }
      if ( Request.Form("irFarY1") != "" ) {
        irFarY1 = Request.Form("irFarY1");
      }
      if ( Request.Form("irFarX2") != "" ) {
        irFarX2 = Request.Form("irFarX2");
      }
      if ( Request.Form("irFarY2") != "" ) {
        irFarY2 = Request.Form("irFarY2");
      }
      if ( Request.Form("visFarX0") != "" ) {
        visFarX0 = Request.Form("visFarX0");
      }
      if ( Request.Form("visFarY0") != "" ) {
        visFarY0 = Request.Form("visFarY0");
      }
      if ( Request.Form("visFarX1") != "" ) {
        visFarX1 = Request.Form("visFarX1");
      }
      if ( Request.Form("visFarY1") != "" ) {
        visFarY1 = Request.Form("visFarY1");
      }
      if ( Request.Form("visFarX2") != "" ) {
        visFarX2 = Request.Form("visFarX2");
      }
      if ( Request.Form("visFarY2") != "" ) {
        visFarY2 = Request.Form("visFarY2");
      }
      if ( Request.Form("offNearX") != "" ) {
        offNearX = Request.Form("offNearX");
      }
      if ( Request.Form("offNearY") != "" ) {
        offNearY = Request.Form("offNearY");
      }
      if ( Request.Form("offFarX") != "" ) {
        offFarX = Request.Form("offFarX");
      }
      if ( Request.Form("offFarY") != "" ) {
        offFarY = Request.Form("offFarY");
      }

      /*
       * Extract Current and stored distances from URL
       */
      if ( Request.Form("distNear") != "" ) {
        distNear = 1*toDecPoint(Request.Form("distNear"));
      }
      if ( Request.Form("distFar") != "" ) {
        distFar = 1*toDecPoint(Request.Form("distFar"));
      }

      /*
       * Extract focus positions from URL
       */
      if ( Request.Form("focusNear") != "" ) {
        focusNear = 1*Request.Form("focusNear");
      }
      if ( Request.Form("focusFar") != "" ) {
        focusFar = 1*Request.Form("focusFar");
      }

      /*
       * Extract skipFocusCheck from URL
       */
      if ( Request.Form("SkipFocusCheck") != "" ) {
        strSkipFocusCheck = "checked "
      }
      restree.setResourceValue( "prod.syscalib.cmdargAlign.skipFocusCheck",( Request.Form( "skipFocusCheck" ) != "" ));     

      /*
       * Extract image filenames from URL
       */
      if ( Request.Form("irNearFile") != "" ) {
        irNearFile = Request.Form("irNearFile");
      }
      if ( Request.Form("irFarFile") != "" ) {
        irFarFile = Request.Form("irFarFile");
      }
      if ( Request.Form("visNearFile") != "" ) {
        visNearFile = Request.Form("visNearFile");
      }
      if ( Request.Form("visFarFile") != "" ) {
        visFarFile = Request.Form("visFarFile");
      }
      
      /*
       * Decode the command.
       */
      if ( Request.Form("newImage") != "" )
      {
        // Grab both IR and visual images.
        getNewImages( distMode );
      }
      else if ( Request.Form("focus") != "" )
      {
		 if( CamType == "X2" ) {
		    restree.setResourceValue( "image.services.channel.active", "IR" );
			restree.setResourceValue( "image.services.channel.commit", true );

			if( restree.getResourceValue( ".prod.syscalib.cmdargAlign.showFocus" ) ) {
			    restree.setResourceValue( ".prod.syscalib.cmdargAlign.showFocus", false );
			}
			else {
				/*
				 * Activat "focus helper".
				 */
			    restree.setResourceValue( ".prod.syscalib.cmdargAlign.showFocus", true );
			}

		}
		else {
			  // Perform a autofocus operation.
			  restree.setResourceValue("system.focus.autofull", true);
			  var i = 500;
			 restree.sleep( 200 );
			  while (restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
				  restree.sleep( 200 );
	      getNewIrImage( distMode );
	      }             
      }
      else if ( Request.Form("calculate") != "" )
      {
         // Calculate and save new fusion alignment parameters.

         {
           // Next, setup for and execute a "alignNear" command.
           ECode = restree.getResourceValue("prod.syscalib.ecode");
           strPrompt = restree.getResourceValue("prod.syscalib.prompt");
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRX0", irNearX0);
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRY0", irNearY0);
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRX1", irNearX1);
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRY1", irNearY1);
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRX2", irNearX2);
           restree.setResourceValue("prod.syscalib.cmdargAlign.IRY2", irNearY2);
           // Rescale to 640x480 ?
           if( rescaleVisual )
           {
             var x0 = new Number( visNearX0 / visualScale );
             var x1 = new Number( visNearX1 / visualScale );
             var x2 = new Number( visNearX2 / visualScale );
             var y0 = new Number( visNearY0 / visualScale );
             var y1 = new Number( visNearY1 / visualScale );
             var y2 = new Number( visNearY2 / visualScale );

             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX0", x0.toFixed(0));
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY0", y0.toFixed(0));
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX1", x1.toFixed(0));
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY1", y1.toFixed(0));
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX2", x2.toFixed(0));
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY2", y2.toFixed(0));
           }
           else
           {
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX0", visNearX0);
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY0", visNearY0);
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX1", visNearX1);
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY1", visNearY1);
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisX2", visNearX2);
             restree.setResourceValue("prod.syscalib.cmdargAlign.VisY2", visNearY2);
           }
           restree.setResourceValue("prod.syscalib.cmdargAlign.distance", distNear);
       
           restree.setResourceValue("prod.syscalib.cmdargAlign.autoDetect", false);

           restree.setResourceValue("prod.syscalib.cmdargAlign.focusPos", focusNear);

           restree.setResourceValue("prod.syscalib.command", "alignNear");
           if ( !waitWhileBusy("prod.syscalib.status") )
           {
             ECode = -1;
           }
           else
           {
              ECode = restree.getResourceValue("prod.syscalib.ecode");
              strPrompt = restree.getResourceValue("prod.syscalib.prompt");
              magNear = restree.getResourceValue("prod.syscalib.cmdargAlign.scale");
              rotNear = restree.getResourceValue("prod.syscalib.cmdargAlign.alpha");
           }
           if (ECode != 0)
           {
             bNearError = true;
           }
           else
           {
             // Next, setup for and execute a "alignFar" command.
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRX0", irFarX0);
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRY0", irFarY0);
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRX1", irFarX1);
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRY1", irFarY1);
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRX2", irFarX2);
             restree.setResourceValue("prod.syscalib.cmdargAlign.IRY2", irFarY2);
             // Rescale to 640x480 ?
             if( rescaleVisual )
             {
               var x0 = new Number( visFarX0 / visualScale );
               var x1 = new Number( visFarX1 / visualScale );
               var x2 = new Number( visFarX2 / visualScale );
               var y0 = new Number( visFarY0 / visualScale );
               var y1 = new Number( visFarY1 / visualScale );
               var y2 = new Number( visFarY2 / visualScale );

               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX0", x0.toFixed(0));
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY0", y0.toFixed(0));
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX1", x1.toFixed(0));
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY1", y1.toFixed(0));
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX2", x2.toFixed(0));
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY2", y2.toFixed(0));
             }
             else
             {
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX0", visFarX0);
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY0", visFarY0);
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX1", visFarX1);
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY1", visFarY1);
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisX2", visFarX2);
               restree.setResourceValue("prod.syscalib.cmdargAlign.VisY2", visFarY2);
             }

             restree.setResourceValue("prod.syscalib.cmdargAlign.distance", distFar);
         
             restree.setResourceValue("prod.syscalib.cmdargAlign.autoDetect", false);

             restree.setResourceValue("prod.syscalib.cmdargAlign.focusPos", focusFar);

             restree.setResourceValue("prod.syscalib.command", "alignFar");
             if ( !waitWhileBusy("prod.syscalib.status") )
             {
               ECode = -1;
             }
             else
             {
               ECode = restree.getResourceValue("prod.syscalib.ecode");
               strPrompt = restree.getResourceValue("prod.syscalib.prompt");
               magFar = restree.getResourceValue("prod.syscalib.cmdargAlign.scale");
               rotFar = restree.getResourceValue("prod.syscalib.cmdargAlign.alpha");
             }
             if (ECode != 0)
             {
               bFarError = true;
               ECode = restree.getResourceValue("prod.syscalib.ecode");
               strPrompt = restree.getResourceValue("prod.syscalib.prompt");
             }
             else
             {
               // Last, execute a "alignStore" command.
               restree.setResourceValue("prod.syscalib.command", "alignStore");
               if ( !waitWhileBusy("prod.syscalib.status") )
               {
                 ECode = -1;
               }
               else
               {
                 ECode = restree.getResourceValue("prod.syscalib.ecode");
                 strPrompt = restree.getResourceValue("prod.syscalib.prompt");
				 restree.setResourceValue( "image.flow.lens.triggerLensChange", true );
               }
               if (ECode != 0)
               {
                 bStoreError = true;
               }
             }
           }
         }
 
      }

      C2 = restree.getResourceValue("system.focus.lens.C2X");
      C3 = restree.getResourceValue("system.focus.lens.C3X");    

    }
    // Remember which calculation phase that went wrong.
    if( bInitError )
      ErrorPhase = "Initialise";
    else if( bNearError )
      ErrorPhase = "Near";
    else if( bFarError )
      ErrorPhase = "Far";
    else if( bStoreError )
      ErrorPhase = "Store";
    else
      ErrorPhase = "Unknown";

  }
  var strTitle = "Alignment ( Fusion and focus )"; 
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">

<!--
  *****************************************************************
  Client side Javascript code to deal with image selection/panning
  and haircross positioning.
  *****************************************************************
-->

<SCRIPT type="text/javascript">

  /*
   * Transfer position information from server side Jscript to client side JavaScript.
   */
  var irNearState =  { point0: { x: <%Response.Write( irNearX0 );%>, y: <%Response.Write( irNearY0 );%> },
                       point1: { x: <%Response.Write( irNearX1 );%>, y: <%Response.Write( irNearY1 );%> },
                       point2: { x: <%Response.Write( irNearX2 );%>, y: <%Response.Write( irNearY2 );%> },
                       filename: "<%Response.Write( irNearFile );%>"
                     };
  var irFarState =   { point0: { x: <%Response.Write( irFarX0 );%>, y: <%Response.Write( irFarY0 );%> },
                       point1: { x: <%Response.Write( irFarX1 );%>, y: <%Response.Write( irFarY1 );%> },
                       point2: { x: <%Response.Write( irFarX2 );%>, y: <%Response.Write( irFarY2 );%> },
                       filename: "<%Response.Write( irFarFile );%>"
                     };
  var visNearState = { point0: { x: <%Response.Write( visNearX0 );%>, y: <%Response.Write( visNearY0 );%> },
                       point1: { x: <%Response.Write( visNearX1 );%>, y: <%Response.Write( visNearY1 );%> },
                       point2: { x: <%Response.Write( visNearX2 );%>, y: <%Response.Write( visNearY2 );%> },
                       offset: { x: <%Response.Write( offNearX );%>,  y: <%Response.Write( offNearY );%> },
                       filename: "<%Response.Write( visNearFile );%>"
                     };
  var visFarState =  { point0: { x: <%Response.Write( visFarX0 );%>, y: <%Response.Write( visFarY0 );%> },
                       point1: { x: <%Response.Write( visFarX1 );%>, y: <%Response.Write( visFarY1 );%> },
                       point2: { x: <%Response.Write( visFarX2 );%>, y: <%Response.Write( visFarY2 );%> },
                       offset: { x: <%Response.Write( offFarX );%>,  y: <%Response.Write( offFarY );%> },
                       filename: "<%Response.Write( visFarFile );%>"
                     };

  var distMode = "<%Response.Write( distMode );%>";
  var imgMode = "<%Response.Write( imgMode );%>";
  var presentImage = "";
  var irRatioBmpToOrig = <%Response.Write( ratioBmpToIR );%>;
  var visRatioBmpToOrig = <%Response.Write( ratioBmpToVisual );%>;
  var irBmpWidth = <%Response.Write( bmpWidthIR );%>;
  var irBmpHeight = <%Response.Write( bmpHeightIR );%>;
  var visBmpWidth = <%Response.Write( bmpWidthVisual );%>;
  var visBmpHeight = <%Response.Write( bmpHeightVisual );%>;
  var BmpWidth = 0;
  var BmpHeight = 0;
  var RatioBmpToOrig = 0;
  var WinWidth = <%Response.Write( winWidth );%>;
  var WinHeight = <%Response.Write( winHeight );%>;
  var WinTopMarg = 10;
  var WinLeftMarg = 10;
  var xhairSize = 41;
  var halfXhairSize = 20;

  var pixtop = WinTopMarg;
  var pixleft = WinLeftMarg;
  var right = WinWidth + WinLeftMarg;
  var left = 0;
  var top = 0;
  var bottom = WinHeight + WinTopMarg;
  var draggedElem = null; 
  var mouseButtonDown = false; 
  var selectedHC = 0;
  var startIX = 0;
  var startIY = 0;
  var startMX = 0;
  var startMY = 0;
  var screenXpos = new Array( 0, 0, 0 );
  var screenYpos = new Array( 0, 0, 0 );
  var HcXPos = new Array( 0, 0, 0 );
  var HcYPos = new Array( 0, 0, 0 );
  var origoX = 200;  // "mainpane" offset from left edge of window.
  var origoY = 100;  // "mainpane" offset from top of window.

  /*
   * Return true if executing on MS Internet Explorer
   */
  function isIE() {
    return (navigator.appName == "Microsoft Internet Explorer");
  }

  /*
   * Position the zoomed image in the image window.
   * Update all 3 haircross markers.
   */
  function setPos( pTop, pBottom, pLeft, pRight )
  {

    var i;

    // Set image position and clipping.
    var vp = "rect( " + pTop + "px " + pRight + "px " + pBottom + "px " + pLeft + "px )";
    document.getElementById("imgBmpClipDiv").style.clip = vp;
    vp = pixtop + "px";
    document.getElementById("imgBmpClipDiv").style.top = vp;
    vp = pixleft + "px";
    document.getElementById("imgBmpClipDiv").style.left = vp;
    // Set haircross position and clipping.
    for( i = 0; i < 3; i++ )
    {
      var xClip = 
            ( ( screenXpos[ i ] - left ) + xhairSize > WinWidth + WinLeftMarg ?
                  xhairSize - ( ( ( screenXpos[ i ] - left ) + xhairSize ) - ( WinWidth + WinLeftMarg ) ) :
                  xhairSize );
      var yClip = 
            ( ( screenYpos[ i ] - top ) + xhairSize > WinHeight + WinTopMarg ?
                  xhairSize - ( ( ( screenYpos[ i ] - top ) + xhairSize ) - ( WinHeight + WinTopMarg ) ) :
                  xhairSize );
      vp = "rect( " +
           ( screenYpos[ i ] - top < WinTopMarg ? WinTopMarg - ( screenYpos[ i ] - top ) : 0 ) + "px " +
           xClip + "px " +
           yClip + "px " +
           ( screenXpos[ i ] -left < WinLeftMarg ? WinLeftMarg - ( screenXpos[ i ] - left ) : 0 ) + "px )";
      document.getElementById( "xhair" + (i + 1) + "ClipDiv" ).style.clip = vp;
      vp = ( screenYpos[ i ] - top ) + "px";
      document.getElementById( "xhair" + (i + 1) + "ClipDiv" ).style.top = vp;
      vp = ( screenXpos[ i ] - left ) + "px";
      document.getElementById( "xhair" + (i + 1) + "ClipDiv" ).style.left = vp;
    }
  }

  /*
   * Update a single haircross position by image pixel coordinate.
   */
  function setHairCrossByImagePixel( hcNum, x, y )
 {
    /*
     * Calculate which image pixel pixel occupies this screen position.
     */
    var l = left - origoX;
    var t = top - origoY;
    var p = RatioBmpToOrig;
    var d = "";
    var m = "";

    HcXPos[ hcNum ] = x;
    HcYPos[ hcNum ] = y;
    if( HcXPos[ hcNum ] <= 0 )
      HcXPos[ hcNum ] = 0;
    else if ( HcXPos[ hcNum ] >= BmpWidth/RatioBmpToOrig )
      HcXPos[ hcNum ] = BmpWidth/RatioBmpToOrig-1;

    if( HcYPos[ hcNum ] <= 0 )
      HcYPos[ hcNum ] = 0;
    else if ( HcYPos[ hcNum ] >= BmpHeight/RatioBmpToOrig )
      HcYPos[ hcNum ] = BmpHeight/RatioBmpToOrig-1;
    /*
     * Recalculate the screen position using the ir image coordinates.
     * This makes the haircross "snap" to image pixel positions.
     */
    var xp = ( ( HcXPos[ hcNum ] * p ) + WinLeftMarg + ( origoX - left ) + p/2 ) - 0.1;
    var yp = ( ( HcYPos[ hcNum ] * p ) + WinTopMarg + ( origoY - top ) + p/2 ) - 0.1;
    if( isIE() ) {
      xp += <%Response.Write( IEoffset );%>;
      yp += <%Response.Write( IEoffset );%>;
    }
    screenXpos[ hcNum ] = xp - halfXhairSize + l;
    screenYpos[ hcNum ] = yp - halfXhairSize + t;
    // Update image window.
    setPos( top, bottom, left, right );

    // Update haircross position indicators.
    if( distMode == "Near" )
      d = "N";
    else
      d = "F";

    if( imgMode == "Ir" )
      m = "ir";
    else
      m = "vis";

    document.getElementById( m + "Res" + d + hcNum ).value = HcXPos[ hcNum ] + ":" + HcYPos[ hcNum ];
  }

  /*
   * Update a single haircross position by screen coordinate.
   */
  function setHairCross( hcNum, x, y )
  {
    /*
     * Calculate which ir pixel occupies this screen position.
     */
    var l = left - origoX;
    var t = top - origoY;
    var p = RatioBmpToOrig;

    if( isIE() ) {
      x -= <%Response.Write( IEoffset );%>;
      y -= <%Response.Write( IEoffset );%>;
    }
    var nX = new Number( ( l + x - WinLeftMarg - p/2 ) / p );
    var nY = new Number( ( t + y - WinTopMarg - p/2 ) / p );
    
    setHairCrossByImagePixel( hcNum, nX.toFixed(0), nY.toFixed(0));
  }

  /*
   * Move the visual image in the window according to the in arguments.
   */
  function moveWin( mX, mY )
  {
    var diffX = startIX - ( mX - startMX );
    var diffY = startIY - ( mY - startMY );

    left = diffX;
    right = left + WinWidth;
    if( right > BmpWidth ) {
      right = BmpWidth;
      left = BmpWidth - WinWidth;
    }
    if( left < 0 ) {
      left = 0;
      right = WinWidth;
    }
    top = diffY;
    bottom = top + WinHeight;
    if( bottom > BmpHeight ) {
      bottom = BmpHeight;
      top = BmpHeight - WinHeight;
    }
    if( top < 0 ) {
      top = 0;
      bottom = WinHeight;
    }
    pixtop = WinTopMarg - top;
    pixleft = WinLeftMarg - left;
    setPos( top, bottom, left, right );
  }

  /*
   * Check mouse position against haircross positions for this image.
   * Return the numeric id ( 0 - 2 ) of the haircross closest to this position.
   */
  function findSelectedHC( x, y ) {
    var realX;
    var realY;
    var l = left - origoX;
    var t = top - origoY;
    var p = RatioBmpToOrig;

    if( isIE() ) {
      x -= <%Response.Write( IEoffset );%>;
      y -= <%Response.Write( IEoffset );%>;
    }
    var nX = new Number( ( l + x - WinLeftMarg - p/2 ) / p );
    var nY = new Number( ( t + y - WinTopMarg - p/2 ) / p );
    
    realX = nX.toFixed(0);
    realY = nY.toFixed(0);
    var bestDiff = new Number( 999999 );
    var bestMatch = new Number( -1 );
    var presDiff = new Number( 0 );
    for( i = 0; i < 3; i++ )
    {
      presDiff = Math.abs( realX - HcXPos[ i ] ) + Math.abs( realY - HcYPos[ i ] );
      if( presDiff < bestDiff )
      {
        bestDiff = presDiff;
        bestMatch = i;
      }
    }
    return bestMatch;
  }

  /*
   * Mouse movement capture.
   * With ctrl key, move selected haircross.
   * Without ctrl key, move visual image in window.
   */
  function dragIt(evt) {
    evt = (evt) ? evt : (window.event) ? window.event : "";
    var targElem = (evt.target) ? evt.target : evt.srcElement;

    // Ctrl key down ?
    if( mouseButtonDown && evt.ctrlKey ) {
      setHairCross( selectedHC, evt.clientX + document.body.scrollLeft, evt.clientY + document.body.scrollTop );
      return false;
    }
    // Visual image movement enabled ?
    if( draggedElem ) {
      targElem = draggedElem;
      if( targElem.className == "draggable" && imgMode == "Visual" ) {
        while (targElem.id != "imgBmpClipDiv" && targElem.parentNode) {
          targElem = targElem.parentNode;
        }
        if( evt.clientX >= 0 && evt.clientY >= 0 )
          moveWin( evt.clientX, evt.clientY );

        return false;
      }
    }
  }
  /*
   * Event function capturing the mouse button down event.
   */
  function engage(evt) {
     evt = (evt) ? evt : (window.event) ? window.event : "";
     var targElem = (evt.target) ? evt.target : evt.srcElement;
     var hc;

     // If ctrl key down, select the closest haircross
     // and position it according to mouse cursor position.
     if( evt.ctrlKey ) {
       mouseButtonDown = true;
       hc = findSelectedHC( evt.clientX + document.body.scrollLeft, evt.clientY + document.body.scrollTop );
       if( hc >= 0 && hc != selectedHC )
       {
         selectedHC = hc;
         for( i = 0; i < 3; i++ )
         {
           if( i == selectedHC )
             document.getElementById( "hCross" + (i + 1) ).src = "/images/redcross_" + (i + 1) + ".gif";
           else
             document.getElementById(  "hCross" + (i + 1) ).src = "/images/cross_" + (i + 1) + ".gif";
         }
       }
       setHairCross( selectedHC, evt.clientX + document.body.scrollLeft, evt.clientY + document.body.scrollTop );
       return false;
     }
     // If no ctrl key, enable move of visual image in window.
     if( targElem.className == "draggable" && imgMode == "Visual" ) {
       while (targElem.id != "imgBmpClipDiv" && targElem.parentNode) {
         targElem = targElem.parentNode;
       }
       if( targElem.id == "imgBmpClipDiv" ) {
         draggedElem = targElem;
         startMX = evt.clientX;
         startMY = evt.clientY;
         startIX = left;
         startIY = top;
         return false;
      }
    }
  }

  /*
   * Event function capturing the mouse button up event.
   */
  function release(evt) {
    mouseButtonDown = false;
    draggedElem = null;
  }

  /*
   * Event function capturing mouse out events.
   */
  function chkRelease(evt) {
    evt = (evt) ? evt : (window.event) ? window.event : "";
    if( evt.clientX < 0 ||  evt.clientY < 0 )
      draggedElem = null;
  }

  /*
   * Event function capturing key event.
   * Move selected haircross with ctrl/arrow keys.
   */
  function catchArrows(evt) {
     var bRetCode = true;
     evt = (evt) ? evt : (window.event) ? window.event : "";
     if (evt && evt.ctrlKey )
     {
        var keyCode = evt.keyCode;
        switch (keyCode)
        {
        case 37:
          setHairCrossByImagePixel(selectedHC, (1*HcXPos[ selectedHC ])-1, HcYPos[ selectedHC ]);
          bRetCode = false;
          evt.cancelBubble = true;
          if( evt.stopPropagation )
            evt.stopPropagation();

          break;
        case 38:
          setHairCrossByImagePixel(selectedHC, HcXPos[ selectedHC ], (1*HcYPos[ selectedHC ])-1);
          bRetCode = false;
          evt.cancelBubble = true;
          if( evt.stopPropagation )
            evt.stopPropagation();

          break;
        case 39:
          setHairCrossByImagePixel(selectedHC, (1*HcXPos[ selectedHC ]+1), HcYPos[ selectedHC ]);
          bRetCode = false;
          evt.cancelBubble = true;
          if( evt.stopPropagation )
            evt.stopPropagation();

          break;
        case 40:
          setHairCrossByImagePixel(selectedHC, HcXPos[ selectedHC ], (1*HcYPos[ selectedHC ])+1);
          bRetCode = false;
          evt.cancelBubble = true;
          if( evt.stopPropagation )
            evt.stopPropagation();

          break;
        }
     }
     return bRetCode;
  }

  /*
   * Init ir window according to present setup.
   */
  function setupImage()
  {
    var i;

    // Position ir image in window.
    draggedElem = null; 
    setPos( top, bottom, left, right );
    // Position crosshairs
    for( i = 0; i < 3; i++ )
    {
      if( i == selectedHC )
        document.getElementById( "hCross" + (i + 1) ).src = "/images/redcross_" + (i + 1) + ".gif";
      else
        document.getElementById(  "hCross" + (i + 1) ).src = "/images/cross_" + (i + 1) + ".gif";

      setHairCrossByImagePixel( i, HcXPos[ i ], HcYPos[ i ] );
    }
  }

  /*
   * Transfer present state to storage container.
   */
  function saveState()
  {
    if( presentImage == "irNear" )
    {
      irNearState.point0.x = HcXPos[ 0 ];
      irNearState.point0.y = HcYPos[ 0 ];
      irNearState.point1.x = HcXPos[ 1 ];
      irNearState.point1.y = HcYPos[ 1 ];
      irNearState.point2.x = HcXPos[ 2 ];
      irNearState.point2.y = HcYPos[ 2 ];
    }
    else if( presentImage == "irFar" )
    {
      irFarState.point0.x = HcXPos[ 0 ];
      irFarState.point0.y = HcYPos[ 0 ];
      irFarState.point1.x = HcXPos[ 1 ];
      irFarState.point1.y = HcYPos[ 1 ];
      irFarState.point2.x = HcXPos[ 2 ];
      irFarState.point2.y = HcYPos[ 2 ];
    }
    else if( presentImage == "visNear" )
    {
      visNearState.point0.x = HcXPos[ 0 ];
      visNearState.point0.y = HcYPos[ 0 ];
      visNearState.point1.x = HcXPos[ 1 ];
      visNearState.point1.y = HcYPos[ 1 ];
      visNearState.point2.x = HcXPos[ 2 ];
      visNearState.point2.y = HcYPos[ 2 ];
	    visNearState.offset.x = left;
      visNearState.offset.y = top;
    }
    else if( presentImage == "visFar" )
    {
      visFarState.point0.x = HcXPos[ 0 ];
      visFarState.point0.y = HcYPos[ 0 ];
      visFarState.point1.x = HcXPos[ 1 ];
      visFarState.point1.y = HcYPos[ 1 ];
      visFarState.point2.x = HcXPos[ 2 ];
      visFarState.point2.y = HcYPos[ 2 ];
      visFarState.offset.x = left;
      visFarState.offset.y = top;
    }
  }

  /*
   * Switch to another image. (irNear, visualNear, irFar or visualFar).
   */
  function selectImage()
  {
    saveState();
    presentImage = document.getElementById( "imgSelect" ).value;
    if( presentImage == "irNear" )
    {
      document.getElementById("imgBmp").src = irNearState.filename;
      document.getElementById("imgBmp").width = irBmpWidth;
      document.getElementById("imgBmp").height = irBmpHeight;
      document.getElementById("Focus").disabled = false;
      imgMode = "Ir";
      distMode = "Near";
      BmpWidth = irBmpWidth;
      BmpHeight = irBmpHeight;
      RatioBmpToOrig = irRatioBmpToOrig;
      HcXPos[ 0 ] = irNearState.point0.x;
      HcYPos[ 0 ] = irNearState.point0.y;
      HcXPos[ 1 ] = irNearState.point1.x;
      HcYPos[ 1 ] = irNearState.point1.y;
      HcXPos[ 2 ] = irNearState.point2.x;
      HcYPos[ 2 ] = irNearState.point2.y;
      left = 0;
      top = 0;
      right = WinWidth;
      bottom = WinHeight;
    }
    else if( presentImage == "irFar" )
    {
      document.getElementById("imgBmp").src = irFarState.filename;
      document.getElementById("imgBmp").width = irBmpWidth;
      document.getElementById("imgBmp").height = irBmpHeight;
      document.getElementById("Focus").disabled = false;
      imgMode = "Ir";
      distMode = "Far";
      BmpWidth = irBmpWidth;
      BmpHeight = irBmpHeight;
      RatioBmpToOrig = irRatioBmpToOrig;
      HcXPos[ 0 ] = irFarState.point0.x;
      HcYPos[ 0 ] = irFarState.point0.y;
      HcXPos[ 1 ] = irFarState.point1.x;
      HcYPos[ 1 ] = irFarState.point1.y;
      HcXPos[ 2 ] = irFarState.point2.x;
      HcYPos[ 2 ] = irFarState.point2.y;
      left = 0;
      top = 0;
      right = WinWidth;
      bottom = WinHeight;
    }
    else if( presentImage == "visNear" )
    {
      document.getElementById("imgBmp").src = visNearState.filename;
      document.getElementById("imgBmp").width = visBmpWidth;
      document.getElementById("imgBmp").height = visBmpHeight;
      document.getElementById("Focus").disabled = true;
      imgMode = "Visual";
      distMode = "Near";
      BmpWidth = visBmpWidth;
      BmpHeight = visBmpHeight;
      RatioBmpToOrig = visRatioBmpToOrig;
      HcXPos[ 0 ] = visNearState.point0.x;
      HcYPos[ 0 ] = visNearState.point0.y;
      HcXPos[ 1 ] = visNearState.point1.x;
      HcYPos[ 1 ] = visNearState.point1.y;
      HcXPos[ 2 ] = visNearState.point2.x;
      HcYPos[ 2 ] = visNearState.point2.y;
      left = visNearState.offset.x;
      top = visNearState.offset.y;
      right = left + WinWidth;
      if( right > BmpWidth ) {
        right = BmpWidth;
        left = BmpWidth - WinWidth;
      }
      if( left < 0 ) {
        left = 0;
        right = WinWidth;
      }
      bottom = top + WinHeight;
      if( bottom > BmpHeight ) {
        bottom = BmpHeight;
        top = BmpHeight - WinHeight;
      }
      if( top < 0 ) {
        top = 0;
        bottom = WinHeight;
      }
    }
    else // if( presentImage == "visFar" )
    {
      document.getElementById("imgBmp").src = visFarState.filename;
      document.getElementById("imgBmp").width = visBmpWidth;
      document.getElementById("imgBmp").height = visBmpHeight;
      document.getElementById("Focus").disabled = true;
      imgMode = "Visual";
      distMode = "Far";
      BmpWidth = visBmpWidth;
      BmpHeight = visBmpHeight;
      RatioBmpToOrig = visRatioBmpToOrig;
      HcXPos[ 0 ] = visFarState.point0.x;
      HcYPos[ 0 ] = visFarState.point0.y;
      HcXPos[ 1 ] = visFarState.point1.x;
      HcYPos[ 1 ] = visFarState.point1.y;
      HcXPos[ 2 ] = visFarState.point2.x;
      HcYPos[ 2 ] = visFarState.point2.y;
      left = visFarState.offset.x;
      top = visFarState.offset.y;
      right = left + WinWidth;
      if( right > BmpWidth ) {
        right = BmpWidth;
        left = BmpWidth - WinWidth;
      }
      if( left < 0 ) {
        left = 0;
        right = WinWidth;
      }
      bottom = top + WinHeight;
      if( bottom > BmpHeight ) {
        bottom = BmpHeight;
        top = BmpHeight - WinHeight;
      }
      if( top < 0 ) {
        top = 0;
        bottom = WinHeight;
      }
    }
    pixtop = WinTopMarg - top;
    pixleft = WinLeftMarg - left;
    selectedHC = 0;
    setupImage();
  }

  /*
   * Show the image in the window according to present state.
   * Update onscreen position indicators.
   */
  function initPage()
  {
    selectImage();
    document.getElementById( "irResN0" ).value = irNearState.point0.x + ":" + irNearState.point0.y;
    document.getElementById( "irResN1" ).value = irNearState.point1.x + ":" + irNearState.point1.y;
    document.getElementById( "irResN2" ).value = irNearState.point2.x + ":" + irNearState.point2.y;
    document.getElementById( "irResF0" ).value = irFarState.point0.x + ":" + irFarState.point0.y;
    document.getElementById( "irResF1" ).value = irFarState.point1.x + ":" + irFarState.point1.y;
    document.getElementById( "irResF2" ).value = irFarState.point2.x + ":" + irFarState.point2.y;
    document.getElementById( "visResN0" ).value = visNearState.point0.x + ":" + visNearState.point0.y;
    document.getElementById( "visResN1" ).value = visNearState.point1.x + ":" + visNearState.point1.y;
    document.getElementById( "visResN2" ).value = visNearState.point2.x + ":" + visNearState.point2.y;
    document.getElementById( "visResF0" ).value = visFarState.point0.x + ":" + visFarState.point0.y;
    document.getElementById( "visResF1" ).value = visFarState.point1.x + ":" + visFarState.point1.y;
    document.getElementById( "visResF2" ).value = visFarState.point2.x + ":" + visFarState.point2.y;
  }

  /*
   * Update hidden fields in the forms before submitting the data to the web server.
   * This transfers position information etc. from client side JavaScript to
   * server side Jscript.
   */
  function onSubmitFunc()
  {
    var f;
    
    saveState();
    f = document.getElementById("imagehandling");

    f.irNearX0.value = irNearState.point0.x;
    f.irNearY0.value = irNearState.point0.y;
    f.irNearX1.value = irNearState.point1.x;
    f.irNearY1.value = irNearState.point1.y;
    f.irNearX2.value = irNearState.point2.x;
    f.irNearY2.value = irNearState.point2.y;
    f.visNearX0.value = visNearState.point0.x;
    f.visNearY0.value = visNearState.point0.y;
    f.visNearX1.value = visNearState.point1.x;
    f.visNearY1.value = visNearState.point1.y;
    f.visNearX2.value = visNearState.point2.x;
    f.visNearY2.value = visNearState.point2.y;
    f.irFarX0.value = irFarState.point0.x;
    f.irFarY0.value = irFarState.point0.y;
    f.irFarX1.value = irFarState.point1.x;
    f.irFarY1.value = irFarState.point1.y;
    f.irFarX2.value = irFarState.point2.x;
    f.irFarY2.value = irFarState.point2.y;
    f.visFarX0.value = visFarState.point0.x;
    f.visFarY0.value = visFarState.point0.y;
    f.visFarX1.value = visFarState.point1.x;
    f.visFarY1.value = visFarState.point1.y;
    f.visFarX2.value = visFarState.point2.x;
    f.visFarY2.value = visFarState.point2.y;
    f.offNearX.value = visNearState.offset.x;
    f.offNearY.value = visNearState.offset.y;
    f.offFarX.value = visFarState.offset.x;
    f.offFarY.value = visFarState.offset.y;
    f.distNear.value = document.getElementById( "nearDist" ).value;
    f.distFar.value = document.getElementById( "farDist" ).value;
    f.irNearFile.value = irNearState.filename;
    f.irFarFile.value = irFarState.filename;
    f.visNearFile.value = visNearState.filename;
    f.visFarFile.value = visFarState.filename;
    return true;
  }

</SCRIPT>

    <STYLE type="text/css">
      #imgBmpClipDiv {
        position: absolute;
        left: auto; top: auto;
        height: auto;
        width: auto;
        overflow: hidden;
        z-index: 1;
        clip: rect( 10px 10px 10px 10px);
      }
      #xhair1ClipDiv {
        position: absolute;
        left: 0px; top: 0px;
        height: 41px; width: 41px;
        background-color: none;
        overflow: hidden;
        z-index: 2;
        clip: rect( 10px 10px 10px 10px);
      }
      #xhair2ClipDiv {
        position: absolute;
        left: 20px; top: 20px;
        height: 41px; width: 41px;
        background-color: none;
        overflow: hidden;
        z-index: 2;
        clip: rect( 10px 10px 10px 10px);
      }
      #xhair3ClipDiv {
        position: absolute;
        left: 40px; top: 40px;
        height: 41px; width: 41px;
        background-color: none;
        overflow: hidden;
        z-index: 2;
        clip: rect( 10px 10px 10px 10px);
      }
      td
      {
        padding:0px,0px,0px,0px;
	margin-bottom:0px;
	margin-top:0px;
      }
      
    </STYLE>

    </head>
    <body id="pgFocusAlignment" OnLoad="initPage()">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuFocus", "mnuFocusAlignment" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <TABLE WIDTH="<%if( CamType == "X2" ) Response.Write( winWidth + 450 ); else Response.Write( winWidth + 500 );%>">
                    <TR>
                      <TD VALIGN="top" WIDTH="<%Response.Write( winWidth + 20 );%>" HEIGHT="<%Response.Write( winHeight );%>" >
                        <div id="imgBmpClipDiv" class="draggable">
                          <img name="imgBmp" id="imgBmp" src="/images/noimage.jpg" width="<%Response.Write( winWidth );%>" height="<%Response.Write( winHeight );%>" class="draggable">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                        <div id="xhair1ClipDiv" class="draggable">
                          <img name="hCross1" id="hCross1" src="/images/cross_1.gif">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                        <div id="xhair2ClipDiv" class="draggable">
                          <img name="hCross2" id="hCross2" src="/images/cross_2.gif">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                        <div id="xhair3ClipDiv" class="draggable">
                          <img name="hCross3" id="hCross3" src="/images/cross_3.gif">
                          <script type="text/javascript">
                            document.onmousedown = engage;
                            document.onmouseup = release;
                            document.onmousemove = dragIt;
                            document.onmouseout = chkRelease;
                            document.onkeydown = catchArrows;
                          </script>
                        </div>
                      </TD>
                      <TD VALIGN="top" >
						<%if( CamType == "X2" ) {
							 Response.Write( "<h2>Instruction</h2> \
							<p>Prepare the camera and the targets for the <b>Near</b> target measurements.<br> \
							   Activate helper for manual focus by pressing  <b>Focus</b> button. \
								Move focus ring from end to end slowly several times. Then adjust focus untill the \
								spot meter is at top and image is in best focus. <br>Read a new pair of images by pressing  <b>New Images</b> 	\
							<p>Place the crosshairs in identical positions on both images using <b>Ctrl+mouseclick</b>.<br> \
							   Repeat the procedure with the <b>Far</b> targets.</p> \
							<p>Fill in the <b>Near</b> and <b>Far</b> distances. \
							   Press <b>Calculate</b> to calculate and save a new alignment.<br> \
							   The marker positions can be adjusted and the alignment recalculated if needed.</p> " );
						}
						else {
							 Response.Write( "<h2>Instruction</h2> \
							<p>Prepare the camera and the targets for the <b>Near</b> measurements.<br> \
							   Always <b>Focus</b> the camera before pressing <b>New Images</b> to capture IR and Visual images.<br> \
							<p>Place the crosshairs in identical positions on both images using <b>Ctrl+mouseclick</b>.<br> \
							   Repeat the procedure with the <b>Far</b> targets.</p> \
							<p>Fill in the <b>Near</b> and <b>Far</b> distances. \
							   Press <b>Calculate</b> to calculate and save a new alignment.<br> \
							   The marker positions can be adjusted and the alignment recalculated if needed.</p> " );
						}
            if( ECode > 0 )
              {
                Response.Write("<b>Error in " + ErrorPhase + " stage</b><br>");
                Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;");
                if ( strPrompt != "" ) Response.Write("<br>" + strPrompt);
              }
              else if( ECode < 0 )
                Response.Write("<span id=errstatus> Production Application not available!</span>&nbsp;");
              else if ( Request.Form.Count > 0)
              {
                  Response.Write("<span id=OKstatus> Command OK </span>&nbsp;");
              }
						  if( ECode == 0 ) {
   						     if((( CamType == "X2" ) && ( xRes < 180 )) || (( CamType == "E" || CamType == "E2" ) && ( xRes < 320 )))
                                 Response.Write("<span id=errstatus> Camera not in service mode </span>&nbsp;");
						  }
         %>
            </TD>
              </TR>
                </TABLE>
                <TABLE ID="Table2">
                    <TR>
                      <FORM ACTION="#" METHOD="post" NAME="imagehandling" ID="imagehandling" OnSubmit="return onSubmitFunc();">
                        <TD valign="top" width="300">
                          <table>
                            <tr>
                              <td>
                                <select name="imgSelect" id="imgSelect" onChange="selectImage()">
                                  <option value="irNear"<% if( imgSelect == "irNear" ) Response.Write( " selected" ); %>>Near IR Image</option>
                                  <option value="visNear"<% if( imgSelect == "visNear" ) Response.Write( " selected" ); %>>Near Visual Image</option>
                                  <option value="irFar"<% if( imgSelect == "irFar" ) Response.Write( " selected" ); %>>Far IR Image</option>
                                  <option value="visFar"<% if( imgSelect == "visFar" ) Response.Write( " selected" ); %>>Far Visual Image</option>
                                </select>
                              </td>
                              <td>
                                <INPUT TYPE="submit" VALUE="Focus" ID="Focus" NAME="Focus"  <%if( imgMode != "Ir" ) Response.Write( "disabled" ); %>>
                              </td>

                              <td style="white-space:nowrap">
                                <input type="checkbox" id="SkipFocusCheck" name="SkipFocusCheck"
                                "<% Response.Write( strSkipFocusCheck ); %>"> Don't verify focus results ( C2, C3 )                  
                              </td>
                              
                            </tr>
                            <tr>
                              <td>
                                <INPUT TYPE="submit" VALUE="New Images" ID="newImage" NAME="newImage">
                              </td>
                              <td>
                                <INPUT TYPE="submit" VALUE="Calculate & Save" ID="calculate" NAME="calculate">
                              </td>
                            </tr>
                          </table>
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearX0" ID="irNearX0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearY0" ID="irNearY0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearX1" ID="irNearX1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearY1" ID="irNearY1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearX2" ID="irNearX2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearY2" ID="irNearY2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearX0" ID="visNearX0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearY0" ID="visNearY0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearX1" ID="visNearX1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearY1" ID="visNearY1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearX2" ID="visNearX2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearY2" ID="visNearY2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarX0" ID="irFarX0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarY0" ID="irFarY0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarX1" ID="irFarX1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarY1" ID="irFarY1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarX2" ID="irFarX2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarY2" ID="irFarY2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarX0" ID="visFarX0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarY0" ID="visFarY0">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarX1" ID="visFarX1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarY1" ID="visFarY1">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarX2" ID="visFarX2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarY2" ID="visFarY2">
                                <INPUT TYPE="hidden" VALUE="0" NAME="offNearX" ID="offNearX">
                                <INPUT TYPE="hidden" VALUE="0" NAME="offNearY" ID="offNearY">
                                <INPUT TYPE="hidden" VALUE="0" NAME="offFarX" ID="offFarX">
                                <INPUT TYPE="hidden" VALUE="0" NAME="offFarY" ID="offFarY">
                                <INPUT TYPE="hidden" VALUE="0" NAME="distNear" ID="distNear">
                                <INPUT TYPE="hidden" VALUE="0" NAME="distFar" ID="distFar">
                                <INPUT TYPE="hidden" VALUE="<%Response.Write( focusNear );%>" NAME="focusNear" ID="focusNear">
                                <INPUT TYPE="hidden" VALUE="<%Response.Write( focusFar );%>" NAME="focusFar" ID="focusFar">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irNearFile" ID="irNearFile">
                                <INPUT TYPE="hidden" VALUE="0" NAME="irFarFile" ID="irFarFile">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visNearFile" ID="visNearFile">
                                <INPUT TYPE="hidden" VALUE="0" NAME="visFarFile" ID="visFarFile">
                        </td>
                      </FORM>
                    </TR>
                <tr>
                </table>
                <FORM ACTION="#" METHOD="post" NAME="results" ID="results" OnSubmit="return false;">
                <table>
                 <td valign=top>
                    <table>
                     <tr>
                      <td valign="top">
                       <h3>Near distance&nbsp;&nbsp;</h3>
                      </td>
                      <td valign="top">
                       <input type="text" name="nearDist" id="nearDist" size="6" value="<% if ( distNear > 0 ) Response.Write( distNear );%>"> m
                      </td>
                     </tr>
                    </table>
                    <TABLE border="2" ID="Table1" height="84">
                      <TR >
                            <TD valign="top">
                            Marker
                            </td>
                            <TD valign="top" width="60">
                            1
                            </td>
                            <TD valign="top" width="60">
                            2
                            </td>
                            <TD valign="top" width="60">
                            3
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            Visual
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResN0" id="visResN0" size="8" value="<% if ( visNearX0 > 0 || visNearY0 > 0 ) Response.Write( visNearX0 + ":" + visNearY0 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResN1" id="visResN1" size="8" value="<% if ( visNearX1 > 0 || visNearY1 > 0 ) Response.Write( visNearX1 + ":" + visNearY1 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResN2" id="visResN2" size="8" value="<% if ( visNearX2 > 0 || visNearY2 > 0 ) Response.Write( visNearX2 + ":" + visNearY2 ); else Response.Write("&nbsp;");%>">
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            IR
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResN0" id="irResN0" size="8" value="<% if ( irNearX0 > 0 || irNearY0 > 0 ) Response.Write( irNearX0 + ":" + irNearY0 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResN1" id="irResN1" size="8" value="<% if ( irNearX1 > 0 || irNearY1 > 0 ) Response.Write( irNearX1 + ":" + irNearY1 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResN2" id="irResN2" size="8" value="<% if ( irNearX2 > 0 || irNearY2 > 0 ) Response.Write( irNearX2 + ":" + irNearY2 ); else Response.Write("&nbsp;");%>">
                            </td>
                      </TR>
                    </TABLE>
                </td>
                <td valign=top>
                    <table>
                     <tr>
                      <td valign="top">
                       <h3>Far distance&nbsp;&nbsp;</h3>
                      </td>
                      <td valign="top">
                       <input type="text" name="farDist" id="farDist" size="6" value="<% if ( distFar > 0 ) Response.Write( distFar );%>"> m
                      </td>
                     </tr>
                    </table>
                    <TABLE border="2" ID="Table1" height="84">
                      <TR >
                            <TD valign="top">
                            Marker
                            </td>
                            <TD valign="top" width="60">
                            1
                            </td>
                            <TD valign="top" width="60">
                            2
                            </td>
                            <TD valign="top" width="60">
                            3
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            Visual
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResF0" id="visResF0" size="8" value="<% if ( visFarX0 > 0 || visFarY0 > 0 ) Response.Write( visFarX0 + ":" + visFarY0 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResF1" id="visResF1" size="8" value="<% if ( visFarX1 > 0 || visFarY1 > 0 ) Response.Write( visFarX1 + ":" + visFarY1 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="visResF2" id="visResF2" size="8" value="<% if ( visFarX2 > 0 || visFarY2 > 0 ) Response.Write( visFarX2 + ":" + visFarY2 ); else Response.Write("&nbsp;");%>">
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            IR
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResF0" id="irResF0" size="8" value="<% if ( irFarX0 > 0 || irFarY0 > 0 ) Response.Write( irFarX0 + ":" + irFarY0 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResF1" id="irResF1" size="8" value="<% if ( irFarX1 > 0 || irFarY1 > 0 ) Response.Write( irFarX1 + ":" + irFarY1 ); else Response.Write("&nbsp;");%>">
                            </td>
                            <TD valign="top">
                            <input type="text" name="irResF2" id="irResF2" size="8" value="<% if ( irFarX2 > 0 || irFarY2 > 0 ) Response.Write( irFarX2 + ":" + irFarY2 ); else Response.Write("&nbsp;");%>">
                            </td>
                      </TR>
                    </TABLE>
                </td>
                <td valign=top>
                    <table>
                     <tr>
                      <td valign="top">
                       <h3>Fusion result</h3>
                      </td>
                     </tr>
                    </table>
                    <TABLE border="2" ID="Table3" height="84">
                      <TR >
                            <TD valign="top">
                            Distance
                            </td>
                            <TD valign="top" width="60">
                            Near
                            </td>
                            <TD valign="top" width="60">
                            Far
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            Magnific.
                            </td>
                            <TD valign="top" width="60">
                            <%if ( bNearError ) Response.Write("<span id=errstatus>");%>
                            <%if (magNear > 0) {num = magNear; Response.Write(num.toFixed(2));} else Response.Write("&nbsp;");%>
                            <%if ( bNearError ) Response.Write("</span>");%>
                            </td>
                            <TD valign="top" width="60">
                            <%if ( bFarError ) Response.Write("<span id=errstatus>");%>
                            <%if (magFar > 0) {num = magFar; Response.Write(num.toFixed(2));}else Response.Write("&nbsp;");%>
                            <%if ( bFarError ) Response.Write("</span>");%>
                            </td>
                      </TR>
                      <TR >
                            <TD valign="top">
                            Rotation
                            </td>
                            <TD valign="top" width="60">
                            <%if ( bNearError ) Response.Write("<span id=errstatus>");%>
                            <%if (magNear > 0) {num = rotNear; Response.Write(num.toFixed(2));}else Response.Write("&nbsp;");%>
                            <%if ( bNearError ) Response.Write("</span>");%>
                            </td>
                            <TD valign="top" width="60">
                            <%if ( bFarError ) Response.Write("<span id=errstatus>");%>
                            <%if (magFar > 0) {num = rotFar; Response.Write(num.toFixed(2));}else Response.Write("&nbsp;");%>
                            <%if ( bFarError ) Response.Write("</span>");%>
                            </td>
                      </TR>
                    </TABLE>                 
                </td>
                <td valign=top>
                    <table>
                     <tr>
                      <td valign="top">
                       <h3>Focus result</h3>
                      </td>
                     </tr>
                    </table>
                    <TABLE border="2" ID="Table4" height="84">
                      <TR >
                            <TD valign="top">
                            C2
                            </td>
                            <TD valign="top" width="60">
                            C3
                      </TR>
                      <TR >
                            <TD valign="top" width="60">
                            <%if( !bNearError && !bFarError ) { num = C2; Response.Write(num.toFixed(0));} else Response.Write("&nbsp;");%>
                            <%if( bNearError || bFarError  ) Response.Write("</span>");%>
                            </td>
                            <TD valign="top" width="60">
                            <%if( !bNearError && !bFarError ) { num = C3; Response.Write(num.toFixed(2));} else Response.Write("&nbsp;");%>
                            <%if( bNearError || bFarError  ) Response.Write("</span>");%>
                            </td>
                      </TR>
                    </TABLE>                 
                </td>
                </table>
              </FORM>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
