<%@  language="JSCRIPT" %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
  /* Server side scripts */
    
function Init()
{
	// Have we performed init yet ?
	if( !bInitGood )
	{
		bInitGood = true;
		bInitError = false;

		ECode = executeCommand( "alignInit" );
		if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }

		if( CamType == "E3" ) {
			ECode = executeCommand( "getFocusLimits" );
			if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }

			ECode = executeCommand( "SetDefFocParam" );
			if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }
		}
		else {
			/* allow over focus ( is this OK ?? ) */
			restree.setResourceValue( ".system.focus.lens.infOffset", 1000 );
		}
	}
	while( restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
		restree.sleep( 200 );

	return;
}

/*********************************************************
* Get FOL
*********************************************************/
var FocLen = 0.0;

function getFOL()
{
	FocLen = 0.0;
	FocLen = restree.getResourceValue( ".image.flow.lensExt.focLen" );
	if( FocLen == 0.0 )
		FocLen = restree.getResourceValue( ".image.flow.lensInt.focLen" );
	if( FocLen == 0.0 )
		FocLen = restree.getResourceValue( ".image.flow.lens.focLen" );
}

/*********************************************************
* Create a new jpeg ir image on the ram disk.
*********************************************************/

function getNewIR( filename )
{
	restree.setResourceValue( "image.services.channel.active", "IR" );
	restree.setResourceValue( "image.services.channel.commit", true );

	var cnt = 1000;
	while (restree.getResourceValue( "image.services.channel.status" ) != 0 && cnt-- > 0 )
		restree.sleep( 200 );

    restree.setResourceValue( "image.services.store.overlay", false );
    restree.setResourceValue( "image.services.store.usePogo", false );

/*    restree.setResourceValue( "image.services.store.format", "JPEG_no_IR" ); */
    restree.setResourceValue( "image.services.store.format", "JPEG" );

	restree.setResourceValue( "image.services.store.overlay", false );
	restree.setResourceValue( "image.services.store.overwrite", true );
	restree.setResourceValue( "image.services.store.quality", 85 );
	restree.setResourceValue( "image.services.store.filename", filename );
	restree.setResourceValueWait( "image.services.store.commit", true );
	cnt = 100;
	while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
		restree.sleep( 200 );
}

/*********************************************************
* Create a new ir image.
*********************************************************/

function getNewIRImage( distance )
{
	var IRFile = "/Temp/" + distance + "Ir.jpg";
	var RandomVal = Math.random();

	RandomString = new String( RandomVal.toString( 16 ) );
	getNewIR( IRFile );
	if( distance == "Near" || distance == "near" )
	{
		IRNearFile = "/Ram/NearIr.jpg" + "?" + RandomString;
		focusNear = restree.getResourceValue( "system.focus.position" );
	}
	else
	{
		IRFarFile = "/Ram/FarIr.jpg" + "?" + RandomString;
		focusFar = restree.getResourceValue( "system.focus.position" );
	}
}

/*********************************************************
* Execute a prodapp.syscalib command.
*********************************************************/
function executeCommand( cmd )
{
	var retCode;

	restree.setResourceValue("prod.syscalib.command", cmd);
	if ( !waitWhileBusy("prod.syscalib.status") )
	{
		retCode = -1;
	}
	else
	{
		retCode = restree.getResourceValue("prod.syscalib.ecode");
	}
	return retCode;
}

/*********************************************************
* Start of main code body.
*********************************************************/

/* Start the production application, unless already done */
var started = false;

var ValueType = restree.valueType( "prod.syscalib.status" );
if( ValueType != "N/A") /* This works on all types of values */
{ 
	started = true;
}

if( started == false ) 
{
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );
	for( i = 0; i < 1000; i++ ) 
	{
		var ValueType = restree.valueType( "prod.syscalib.status" );
		if( ValueType != "N/A") 
		{
			started = true;
			break;
		}
		restree.sleep( 200 );
	}
}

var curDistace = 1.0;
var imgMode = "Near";
var ECode = -1;
var currentAction = "";
var strPrompt = "";
var C2 = 0;
var C3 = 0;
var strSkipFocusCheck = "";

/*
* Show the IR image at 640x480 on the page.
*/
var winWidth = 640;
var winHeight = 480;

/*
* File names of present near and far .jpg files.
* The file names are the same, but a random argument gets added
* every time a new image is grabbed.
*/
var IRNearFile = "/images/noimage.jpg";
var IRFarFile = "/images/noimage.jpg";
var presFile = "/images/noimage.jpg";
/*
* Distances and focus positions for near and far images.
*/
var nearDistance = 0.5;
var farDistance = 2.5;
var focusNear = 0;
var focusFar = 0;
/*
* Error flags for each stage.
*/
var bInitError = false;
var bNearError = false;
var bFarError = false;
var bStoreError = false;
/*
* Keep track of which stages have been performed successfully.
*/
var bInitGood = false;
var bNearGood = false;
var bFarGood = false;
var bStoreGood = false;
/*
* Error texts.
*/
var ErrorPhase = "Unknown";
var StoreErrText = "";

/*
* Check that we managed to start the production application program.
*/
if( started )
{
	ECode = 0;
	/*
	* Any form data ?
	* No form data indicates a window refresh.
	*/
	if ( Request.Form.Count > 0 )
	{
		/*
		* Extract image mode from URL
		* (near IR, far IR).
		*/
		if ( Request.Form("imgMode") != "" ) {
			imgMode = Request.Form("imgMode");
		}

		/*
		* Extract success flags.
		*/
		if ( Request.Form("initGood") == "true" ) {
			bInitGood = true;
		}
		if ( Request.Form("nearGood") == "true" ) {
			bNearGood = true;
		}
		if ( Request.Form("farGood") == "true" ) {
			bFarGood = true;
		}
		if ( Request.Form("storeGood") == "true" ) {
			bStoreGood = true;
		}

		/*
		* Extract image filenames from URL
		*/
		if ( Request.Form("IRNearFile") != "" ) {
			IRNearFile = Request.Form("IRNearFile");
		}
		if ( Request.Form("IRFarFile") != "" ) {
			IRFarFile = Request.Form("IRFarFile");
		}

		/*
		* Extract focus positions and distances.
		*/
		if ( Request.Form("nearDistance") != "" ) {
			nearDistance = toDecPoint( Request.Form("nearDistance") );
		}
		if ( Request.Form("farDistance") != "" ) {
			farDistance = toDecPoint( Request.Form("farDistance") );
		}

		getNewIRImage( imgMode );

		curDistace = restree.getResourceValue( ".system.focus.distance" );


		/*
		* Decode the command.
		*/
		if ( Request.Form("measure") != "" )
		{
			Init();

			// Perform a focusNear or focusFar operation.
			if( bInitGood )
			{
				if( imgMode == "Near" )
				{
					restree.setResourceValue("prod.syscalib.cmdargAlign.distance", nearDistance);
					ECode = executeCommand( "focusNear" );
					if( ECode != 0 )
					{
						bNearGood = false;
						bNearError = true;
					}
					else
					{
						bNearGood = true;
						bNearError = false;
					}
				}
				else if ( imgMode == "Far" )
				{
					restree.setResourceValue("prod.syscalib.cmdargAlign.distance", farDistance);
					ECode = executeCommand( "focusFar" );
					if( ECode != 0 )
					{
						bFarGood = false;
						bFarError = true;
					}
					else
					{
						bFarGood = true;
						bFarError = false;
					}
				}
			}
		}
		else if ( Request.Form("save") != "" )
		{
			Init();

			// Have we performed init, near and far commands yet ?
			if( bInitGood && bNearGood && bFarGood )
			{
				ECode = executeCommand( "focusStore" );
				if( ECode != 0 ) {
					bStoreGood = false;
					bStoreError = true;
				}
				else {
					if( CamType == "E3" )
						ECode = executeCommand( "CheckFocParam" );
					if( ECode != 0 ) {
						bStoreGood = false;
						bStoreError = true;
					}
					else {
						bStoreGood = true;
						bStoreError = false;
						restree.setResourceValue( "image.flow.lens.triggerLensChange", true );
						restree.sleep( 2000 );
					}
				}
			}
			else
			{
				bStoreError = true;
				bStoreGood = false;
				if( !bNearGood )
					StoreErrText = "No Near measurement found";
				else if( !bFarGood )
					StoreErrText = "No Far measurement found";
			}
		}
		else if ( Request.Form( "focus" ) != "" )
		{
			Init();

			if( bInitGood ) {

				restree.setResourceValue("system.focus.autofull", true );
				var i = 1000;
				restree.sleep( 400 );
				while (restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
					restree.sleep( 200 );

				getNewIRImage( imgMode );
				curDistace = restree.getResourceValue( ".system.focus.distance" );
			}
		}
	}

	C2 = restree.getResourceValue("system.focus.lens.C2X");
	C3 = restree.getResourceValue("system.focus.lens.C3X");    

	// Remember which calculation phase that went wrong.
	if( bInitError )
		ErrorPhase = "Initialise";
	else if( bNearError )
		ErrorPhase = "Near";
	else if( bFarError )
		ErrorPhase = "Far";
	else if( bStoreError )
		ErrorPhase = "Save";
	else
		ErrorPhase = "Unknown";

	if( imgMode == "Near" )
		presFile = IRNearFile;
	else
		presFile = IRFarFile;

}

var strTitle = "Focus Calibration"; 
  
%>
<html>
<head>
  <title>
    <%Response.Write(strTitle + " - " + CamFamily + " Service Web");%>
  </title>
  <link href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
  <!--
  *****************************************************************
  Client side Javascript code to deal with image selection etc.
  *****************************************************************
-->

  <script type="text/javascript">


  var imgMode = "<%Response.Write( imgMode );%>";
  var IRNearFile = "<%Response.Write( IRNearFile );%>";
  var IRFarFile = "<%Response.Write( IRFarFile );%>";
  var presentImage = "";
  var WinWidth = <%Response.Write( winWidth );%>;
  var WinHeight = <%Response.Write( winHeight );%>;

  /*
   * Switch to another image. (IRNear or IRFar).
   */
  function selectImage()
  {
    presentImage = document.getElementById( "imgMode" ).value;
    if( presentImage == "Near" )
    {
      document.getElementById("imgBmp").src = IRNearFile;
      document.getElementById("imgBmp").width = WinWidth;
      document.getElementById("imgBmp").height = WinHeight;
      imgMode = "Near";
    }
    else if( presentImage == "Far" )
    {
      document.getElementById("imgBmp").src = IRFarFile;
      document.getElementById("imgBmp").width = WinWidth;
      document.getElementById("imgBmp").height = WinHeight;
      imgMode = "Far";
    }
  }

  /*
   * Show the image in the window according to present state.
   * Update onscreen position indicators.
   */
  function initPage()
  {
    selectImage();
  }

  /*
   * Update hidden fields in the forms before submitting the data to the web server.
   * This transfers information from client side JavaScript to server side Jscript.
   */
  function onSubmitFunc()
  {
    return true;
  }

  </script>

  <style type="text/css">
        #imgBmpClipDiv {
          position: absolute;
          left: auto; top: auto;
          height: auto;
          width: auto;
          overflow: hidden;
          z-index: 1;
        }
      </style>
</head>
<body id="pgFocus" onload="initPage()">
  <%printStandardDecoration( strTitle );%>
  <%printNavigation( "mnuFocus", "mnuFocusDD" );%>
  <!-- This is the actual contents -->
  <div id="mainpane">
    <div id="content">
      <table width="<%Response.Write( winWidth + 350 );%>">
        <tr>
          <td valign="top" width="<%Response.Write( winWidth + 20 );%>" height="<%Response.Write( winHeight + 10 );%>">
            <div id="imgBmpClipDiv">
              <img name="imgBmp" id="imgBmp" src="<%Response.Write( presFile );%>" width="<%Response.Write( winWidth );%>"
                height="<%Response.Write( winHeight );%>">
            </div>
          </td>
          <td valign="top">
            <h2>
              Instruction</h2>
            <%//Response.Write( "<p>ECode:" + ECode + " ErrorPhase:" + ErrorPhase + "</p>\n" );%>
            <%//Response.Write( "<p>initError:" + bInitError + " nearError:" + bNearError + " farError:" + bFarError + " storeError:" + bStoreError + "</p>\n" );%>
            <%//Response.Write( "<p>initGood:" + bInitGood + " nearGood:" + bNearGood + " farGood:" + bFarGood + " storeGood:" + bStoreGood + "</p>\n" );%>
            <p>
              Point the camera at the Near target and <b>focus</b></p>
            <p>
              Enter <b>Near Distance</b> and press <b>Measure</b> to detect the focus position.</p>
            <p>
              Point the camera at the Far target and <b>focus</b>
            </p>
            Enter <b>Far Distance</b> and press <b>Measure</b> to detect the focus position
            at the Far target.</p>
            <p>
              The <b>Near</b> and/or <b>Far</b> measurements can be repeated if needed.</p>
            <p>
              Press <b>Save</b> to save the new focus calibration.</p>
            <%if( ECode > 0 )
                  {
                    Response.Write("<b>Error in " + ErrorPhase + " stage</b><br>");
                    Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;");
                    if ( strPrompt != "" ) Response.Write("<br>" + strPrompt);
                  }
                  else if( ECode < 0 )
                    Response.Write("<span id=errstatus> Production Application not available!</span>&nbsp;");
                  else if( Request.Form.Count > 0 )
                  {
                    if( !bInitError && !bNearError && !bFarError && !bStoreError )
                      Response.Write("<span id=OKstatus> Command OK </span>&nbsp;");
                    else
                    {
                      if( bStoreError && StoreErrText != "" )
                        Response.Write("<span id=errstatus>" + StoreErrText + "</span><br>");
                      else
                        Response.Write("<span id=errstatus>Error in " + ErrorPhase + " stage</span><br>");
                    }
                  }
            %>
          </td>
        </tr>
      </table>
      <table id="Table2" width="550">
        <tr>
          <form action="#" method="post" name="imagehandling" id="imagehandling" onsubmit="return onSubmitFunc();">
            <td valign="top">
              <table height="30" width="300" cellspacing="4" align="left">
                <tr>
                  <td>
                    <select name="imgMode" id="imgMode" onchange="selectImage()">
                      <option value="Near" <% if( imgMode == "Near" ) Response.Write( " selected" ); %>>
                        Near Distance</option>
                      <option value="Far" <% if( imgMode == "Far" ) Response.Write( " selected" ); %>>Far
                        Distance</option>
                    </select>
                  </td>
                  <td>
                    <input type="submit" value="Measure" id="measure" name="measure">
                  </td>
                  <td>
                    <input type="submit" value="Save" id="save" name="save">
                  </td>
                  <td>
                    <input type="submit" value="Focus" id="focus" name="focus">
                  </td>
                  <td>
                    Measured distance
                    <%Response.Write( curDistace.toFixed(2));%>
                    m
                  </td>
                </tr>
              </table>
            </td>
        </tr>
        <tr>
          <td>
            <table width="550" height="30">
              <tr>
                <td valign="top">
                  <h3>
                    Near distance&nbsp;&nbsp;</h3>
                </td>
                <td valign="top">
                  <input type="text" name="nearDistance" id="nearDistance" size="6" value="<%Response.Write( nearDistance );%>">
                  m
                </td>
                <td valign="top">
                  <h3>
                    Far distance&nbsp;&nbsp;</h3>
                </td>
                <td valign="top">
                  <input type="text" name="farDistance" id="farDistance" size="6" value="<%Response.Write( farDistance );%>">
                  m
                </td>
              </tr>

				<tr>
				  <td style="white-space:nowrap">
					C2: <%if( bStoreGood ) {num = C2; Response.Write(num.toFixed(0));}else Response.Write("&nbsp;");%>
				  </td>
				</tr>

				<tr>
				  <td valign="top" style="white-space:nowrap">
					C3: <%if( bStoreGood ) {num = C3; Response.Write(num.toFixed(2));}else Response.Write("&nbsp;");%>
				  </td>
                </tr>

			  </table>
            <input type="hidden" value="<%Response.Write( IRNearFile );%>" name="IRNearFile"
              id="IRNearFile">
            <input type="hidden" value="<%Response.Write( IRFarFile );%>" name="IRFarFile" id="IRFarFile">
            <input type="hidden" value="<%Response.Write( bInitGood ? "true" : "false" );%>"
              name="initGood" id="initGood">
            <input type="hidden" value="<%Response.Write( bNearGood ? "true" : "false" );%>" name="nearGood" id="nearGood">
            <input type="hidden" value="<%Response.Write( bFarGood  ? "true" : "false" );%>" name="farGood" id="farGood">
            <input type="hidden" value="<%Response.Write( bStoreGood ? "true" : "false" );%>"
              name="storeGood" id="storeGood">
          </td>
          </form>
        </tr>
      </table>
    </div>
    <%printStandardFooter();%>
  </div>
  <!-- End of actual contents -->
</body>
</html>
