    <%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%

function Init()
{
	// Have we performed init yet ?
	if( !bInitGood )
	{
		bInitGood = true;
		bInitError = false;

		ECode = executeCommand( "alignInit" );
		if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }

		if( CamType == "E3" ) {
			ECode = executeCommand( "getFocusLimits" );
			if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }

			ECode = executeCommand( "SetDefFocParam" );
			if( ECode != 0 )  { bInitGood = false; bInitError = true; return; }
		}
		else {
			/* allow over focus ( is this OK ?? ) */
			restree.setResourceValue( ".system.focus.lens.infOffset", 1000 );
		}
	}
	while( restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
		restree.sleep( 200 );

	return;
}

/*********************************************************
* Get FOL
*********************************************************/
var FocLen = 0.0;

function getFOL()
{
	FocLen = 0.0;
	FocLen = restree.getResourceValue( ".image.flow.lensExt.focLen" );
	if( FocLen == 0.0 )
		FocLen = restree.getResourceValue( ".image.flow.lensInt.focLen" );
	if( FocLen == 0.0 )
		FocLen = restree.getResourceValue( ".image.flow.lens.focLen" );
}

/*********************************************************
* Create a new jpeg ir image on the ram disk.
*********************************************************/

function getNewIR( filename )
{
    restree.setResourceValue( "image.services.store.overlay", false );
    restree.setResourceValue( "image.services.store.usePogo", false );

	restree.setResourceValue( "image.services.store.bgActive", false );
/*	restree.setResourceValue( "image.services.store.format", "JPEG_no_IR" ); */
    restree.setResourceValue( "image.services.store.format", "JPEG" );

	restree.setResourceValue( "image.services.store.overwrite", true );
	restree.setResourceValue( "image.services.store.quality", 85 );
	restree.setResourceValue( "image.services.store.filename", filename );
	restree.setResourceValueWait( "image.services.store.commit", true );
	cnt = 100;
	while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
		restree.sleep( 200 );
}

/*********************************************************
* Create a new ir image.
*********************************************************/

function getNewIRImage( distance )
{
	var IRFile = "/Temp/" + distance + "Ir.jpg";
	var RandomVal = Math.random();

	RandomString = new String( RandomVal.toString( 16 ) );
	getNewIR( IRFile );
	IRNearFile = "/Ram/NearIr.jpg" + "?" + RandomString;
	focusNear = restree.getResourceValue( "system.focus.position" );
}

/*********************************************************
* Execute a prodapp.syscalib command.
*********************************************************/

function executeCommand( cmd )
{
	var retCode;

	restree.setResourceValue("prod.syscalib.command", cmd);
	if ( !waitWhileBusy("prod.syscalib.status") )
	{
		retCode = -1;
	}
	else
	{
		retCode = restree.getResourceValue("prod.syscalib.ecode");
	}
	return retCode;
}

/*********************************************************
* Start of main code body.
*********************************************************/

/* Start the production application, unless already done */
var started = false;

var ValueType = restree.valueType( "prod.syscalib.status" );
if( ValueType != "N/A") /* This works on all types of values */
{ 
	started = true;
}

if( started == false ) 
{
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );
	for( i = 0; i < 1000; i++ ) 
	{
		var ValueType = restree.valueType( "prod.syscalib.status" );
		if( ValueType != "N/A") 
		{
			started = true;
			break;
		}
		restree.sleep( 200 );
	}
}

var curDistance = 1.0;
var imgMode = "Near";
var ECode = -1;
var currentAction = "";
var strPrompt = "";
var C2 = 0;
var C3 = 0;
var strSkipFocusCheck = "";
/*
* Show the IR image at 640x480 on the page.
*/
var winWidth = 640;
var winHeight = 480;

/*
* File names of present near .jpg files.
* The file names are the same, but a random argument gets added
* every time a new image is grabbed.
*/
var IRNearFile = "/images/noimage.jpg";
var presFile = "/images/noimage.jpg";
/*
* Distances and focus positions for image.
*/
var nearDistance = 1.0;
var focusNear = 0;
/*
* Error flags for each stage.
*/
var bInitError = false;
var bNearError = false;
var bStoreError = false;
/*
* Keep track of which stages have been performed successfully.
*/
var bInitGood = false;
var bNearGood = false;
var bStoreGood = false;
/*
* Error texts.
*/
var ErrorPhase = "Unknown";
var StoreErrText = "";

/*
* Check that we managed to start the production application program.
*/
	if( started )
	{
		ECode = 0;
		/*
		* Any form data ?
		* No form data indicates a window refresh.
		*/
		if ( Request.Form.Count > 0 )
		{
			/*
			* Extract success flags.
			*/
			if ( Request.Form("initGood") == "true" ) {
				bInitGood = true;
			}
			if ( Request.Form("nearGood") == "true" ) {
				bNearGood = true;
			}
			if ( Request.Form("storeGood") == "true" ) {
				bStoreGood = true;
			}

			/*
			* Extract focus positions and distances.
			*/
			if ( Request.Form("nearDistance") != "" ) {
				nearDistance = toDecPoint( Request.Form("nearDistance") );
			}

			curDistance = restree.getResourceValue( ".system.focus.distance" );

			/*
			* Extract skipFocusCheck from URL
			*/
			if ( Request.Form("SkipFocusCheck") != "" ) {
				strSkipFocusCheck = "checked "
			}
			restree.setResourceValue( "prod.syscalib.cmdargAlign.skipFocusCheck",( Request.Form( "skipFocusCheck" ) != "" ));     

			/*
			* Decode the command.
			*/
			if ( Request.Form("measure") != "" )
			{
				// Perform a focusNear operation.
				Init();

				if( bInitGood )
				{
					restree.setResourceValue("prod.syscalib.cmdargAlign.distance", nearDistance);
					ECode = executeCommand( "focusNear" );
					if( ECode != 0 )
					{
						bNearGood = false;
						bNearError = true;
					}
					else
					{
						bNearGood = true;
						bNearError = false;

						while (restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
							restree.sleep( 200 );
					}
				}
			}
			else if ( Request.Form("save") != "" )
			{
				Init();

				if( bInitGood ) {
					if( bNearGood ) {
						ECode = executeCommand( "focusStore" );
						if( ECode != 0 ) {
							bStoreGood = false;
							bStoreError = true;
						}
						else {
							if( CamType == "E3" )
								ECode = executeCommand( "CheckFocParam" );
							if( ECode != 0 ) {
								bStoreGood = false;
								bStoreError = true;
							}
							else {
								bStoreGood = true;
								bStoreError = false;
								restree.setResourceValue( "image.flow.lens.triggerLensChange", true );
								restree.sleep( 2000 );
							}
						}
					}
					else {
						bStoreError = true;
						bStoreGood = false;
						StoreErrText = "No Near measurement found";
					}
				}
			}
			else if ( Request.Form( "focus" ) != "" )
			{
				Init();
				if( bInitGood ) {
					restree.setResourceValue("system.focus.autofull", true );
					var i = 1000;
					restree.sleep( 200 );
					while (restree.getResourceValue( "system.focus.state" ) == "BUSY" && i-- > 0 )
						restree.sleep( 200 );

					curDistance = restree.getResourceValue( ".system.focus.distance" );
				}
			}
		}

		C2 = restree.getResourceValue("system.focus.lens.C2X");
		C3 = restree.getResourceValue("system.focus.lens.C3X");    

		// Remember which calculation phase that went wrong.
		if( bInitError )
			ErrorPhase = "Initialise";
		else if( bNearError )
			ErrorPhase = "Near";
		else if( bStoreError )
			ErrorPhase = "Save";
		else
			ErrorPhase = "Unknown";

		restree.setResourceValue( "image.services.channel.active", "IR" );
		restree.setResourceValue( "image.services.channel.commit", true );

		var cnt = 1000;
		while (restree.getResourceValue( "image.services.channel.status" ) != 0 && cnt-- > 0 )
			restree.sleep( 200 );

		getNewIRImage( imgMode );

		presFile = IRNearFile;

	}
var strTitle = "Focus Calibration"; 
%>
  <html>
    <head>
      <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
      <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">

<!--
  *****************************************************************
  Client side Javascript code to deal with image selection etc.
  *****************************************************************
-->

<SCRIPT type="text/javascript">


  var imgMode = "<%Response.Write( imgMode );%>";
  var IRNearFile = "<%Response.Write( IRNearFile );%>";
  var presentImage = "";
  var WinWidth = <%Response.Write( winWidth );%>;
  var WinHeight = <%Response.Write( winHeight );%>;

  /*
   * Switch to another image.
   */
  function selectImage()
  {
    presentImage = document.getElementById( "imgMode" ).value;
    document.getElementById("imgBmp").src = IRNearFile;
    document.getElementById("imgBmp").width = WinWidth;
    document.getElementById("imgBmp").height = WinHeight;
    imgMode = "Near";
  }

  /*
   * Show the image in the window according to present state.
   * Update onscreen position indicators.
   */
  function initPage()
  {
    selectImage();
  }

  /*
   * Update hidden fields in the forms before submitting the data to the web server.
   * This transfers information from client side JavaScript to server side Jscript.
   */
  function onSubmitFunc()
  {
    return true;
  }

</SCRIPT>

<META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE">

      <STYLE type="text/css">
        #imgBmpClipDiv {
          position: absolute;
          left: auto; top: auto;
          height: auto;
          width: auto;
          overflow: hidden;
          z-index: 1;
        }
      </STYLE>
    </head>
    <body id="pgFocusSD" OnLoad="initPage()">
      <%printStandardDecoration( strTitle );%>
      <%printNavigation( "mnuFocus", "mnuFocusSD" );%>
      <!-- This is the actual contents -->
      <div id="mainpane">
        <div id="content">
          <TABLE WIDTH="<%Response.Write( winWidth + 350 );%>">
            <TR>
              <TD VALIGN="top" WIDTH="<%Response.Write( winWidth + 20 );%>" HEIGHT="<%Response.Write( winHeight + 10 );%>" >
                <div id="imgBmpClipDiv">
                  <img name="imgBmp" id="imgBmp" src="<%Response.Write( presFile );%>" width="<%Response.Write( winWidth );%>" height="<%Response.Write( winHeight );%>">
                </div>
              </TD>
              <TD VALIGN="top" >
                <h2>Instruction</h2>
                <p>Point the camera at the target and <b>focus</b></p>
                <p>Enter <b>Distance</b> and press <b>Measure</b> to detect the focus position.</p>
                <p>The measurements can be repeated if needed.</p>
                <p>Press <b>Save</b> to save the new focus calibration.</p>

                <%if( ECode > 0 )
                  {
                    Response.Write("<b>Error in " + ErrorPhase + " stage</b><br>");
                    Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;");
                    if ( strPrompt != "" ) Response.Write("<br>" + strPrompt);
                  }
                  else if( ECode < 0 )
                    Response.Write("<span id=errstatus> Production Application not available!</span>&nbsp;");
                  else if( Request.Form.Count > 0 )
                  {
                    if( !bInitError && !bNearError && !bStoreError )
                      Response.Write("<span id=OKstatus> Command OK </span>&nbsp;");
                    else
                    {
                      if( bStoreError && StoreErrText != "" )
                        Response.Write("<span id=errstatus>" + StoreErrText + "</span><br>");
                      else
                        Response.Write("<span id=errstatus>Error in " + ErrorPhase + " stage</span><br>");
                    }
                  }
                %>
              </TD>
            </TR>
          </TABLE>
          <TABLE ID="Table2" width="550">
            <tr>
              <form action="#" method="post" name="imagehandling" id="imagehandling" OnSubmit="return onSubmitFunc();">
                <td valign="top">
                  <table height="30" width="300" cellspacing="4" align="left">
                    <tr>
                      <td style="white-space:nowrap">
                        <INPUT TYPE="submit" VALUE="Measure" ID="measure" NAME="measure">
                      </td >
                      <td>
                        <INPUT TYPE="submit" VALUE="Calculate & Save" ID="save" NAME="save">
                      </td>
                      <td style="white-space:nowrap">
                        <INPUT TYPE="submit" VALUE="Focus" ID="focus" NAME="focus">
                      </td>
                      <td style="white-space:nowrap">
                        <input type="checkbox" id="SkipFocusCheck" name="SkipFocusCheck"
                        "<% Response.Write( strSkipFocusCheck ); %>">                  
                      </td>
                      <td style="white-space:nowrap">
                        Don't verify focus results ( C2, C3 )                    
                      </td>
                      
                    </tr>
                  </table>
                </td>
              </tr>
              <tr>
                <td>
                  <table width="250" height="30">
                    <tr>
                      <td valign="top">
                        <h3>Distance&nbsp;&nbsp;</h3>
                      </td>
                      <td valign="top" style="white-space:nowrap">
                        <input type="text" name="nearDistance" id="nearDistance" size="6" value="<%Response.Write( nearDistance );%>"> m
                      </td>
                    </tr>

                    <tr>
                      <td style="white-space:nowrap">
                        Measured distance: <%Response.Write( curDistance.toFixed(2));%>&nbsp;m
                      </td>
                    </tr>

                    <tr>
                      <td style="white-space:nowrap">
                        C2: <%if( bStoreGood ) {num = C2; Response.Write(num.toFixed(0));}else Response.Write("&nbsp;");%>
                      </td>
                    </tr>

                    <tr>
                      <td valign="top" style="white-space:nowrap">
                        C3: <%if( bStoreGood ) {num = C3; Response.Write(num.toFixed(2));}else Response.Write("&nbsp;");%>
                      </td>
                    </tr>
                  </table>
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( IRNearFile );%>" NAME="IRNearFile" ID="IRNearFile">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bInitGood ? "true" : "false" );%>" NAME="initGood" ID="initGood">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bNearGood ? "true" : "false" );%>" NAME="nearGood" ID="nearGood">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bStoreGood ? "true" : "false" );%>" NAME="storeGood" ID="storeGood">
                </td>
              </form>
            </tr>
          </TABLE>
        </div>
        <%printStandardFooter();%>
      </div>
      <!-- End of actual contents -->
    </body>
  </html>
