    <%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<%
/* Server side scripts */


/*********************************************************
* Create a new jpeg visual image on the ram disk.
*********************************************************/
function getNewVisual( filename )
{

	restree.setResourceValue( "power.settings.laserActive", true );  /* just make shure laser is visible in image */

	restree.setResourceValue( "image.services.channel.active", "VISUAL" );
	restree.setResourceValue( "image.services.channel.commit", true );

	var cnt = 1000;
	while (restree.getResourceValue( "image.services.channel.status" ) != 0 && cnt-- > 0 )
		restree.sleep( 200 );

	restree.setResourceValue( "image.services.store.format", "JPEG_visual" );
	restree.setResourceValue( "image.services.store.overlay", false );
	restree.setResourceValue( "image.services.store.overwrite", true );
	restree.setResourceValue( "image.services.store.quality", 75 );
	restree.setResourceValue( "image.services.store.filename", filename );
	restree.setResourceValueWait( "image.services.store.commit", true );
	cnt = 100;
	while (restree.getResourceValue( "image.services.store.busy" ) != false && cnt-- > 0 )
		restree.sleep( 200 );
	restree.setResourceValue( "power.settings.laserActive", false );
}

/*********************************************************
* Create a new visual image.
*********************************************************/
function getNewVisualImage( distance )
{
	restree.setResourceValue( "system.vcam.active", true );
	var visFile = "/Temp/" + distance + "Vis.jpg";
	var RandomVal = Math.random();

	RandomString = new String( RandomVal.toString( 16 ) );
	getNewVisual( visFile );
	if( distance == "Near" || distance == "near" )
		visNearFile = "/Ram/NearVis.jpg?" + RandomString;
	else
		visFarFile = "/Ram/FarVis.jpg?" + RandomString;
}

/*********************************************************
* Execute a prodapp.syscalib command.
*********************************************************/
function executeCommand( cmd )
{
	var retCode;

	restree.setResourceValue("prod.syscalib.command", cmd);
	if ( !waitWhileBusy("prod.syscalib.status") )
	{
		retCode = -1;
	}
	else
	{
		retCode = restree.getResourceValue("prod.syscalib.ecode");
	}
	return retCode;
}

/*********************************************************
* Start of main code body.
*********************************************************/

/* Start the production application, unless already done */
var started = false;

var ValueType = restree.valueType( "prod.syscalib.status" );
if( ValueType != "N/A") /* This works on all types of values */
{ 
	started = true;
}

if( started == false ) 
{
	restree.setResourceValue( "appl.supv.exec",  "prodapp" );
	for( i = 0; i < 1000; i++ ) 
	{
		var ValueType = restree.valueType( "prod.syscalib.status" );
		if( ValueType != "N/A") 
		{
			started = true;
			break;
		}
		restree.sleep( 200 );
	}
}

var imgMode = "Near";
var ECode = -1;
var currentAction = "";
var strPrompt = "";
/*
* Show the Visual image at 640x480 on the page.
*/
var winWidth = 640;
var winHeight = 480;
/*
* X2 shows the Visual image at 480x480;
*/
if( CamType == "X2" )
winWidth = 480;

/*
* File names of present near and far .jpg files.
* The file names are the same, but a random argument gets added
* every time a new image is grabbed.
*/
var visNearFile = "/images/noimage.jpg";
var visFarFile = "/images/noimage.jpg";
var presFile = "/images/noimage.jpg";
/*
* Distances and focus positions for near and far images.
*/
var nearDistance = 0.5;
var farDistance = 2.5;
var focusNear = 0;
var focusFar = 0;
/*
* Error flags for each stage.
*/
var bInitError = false;
var bNearError = false;
var bFarError = false;
var bStoreError = false;
/*
* Keep track of which stages have been performed successfully.
*/
var bInitGood = false;
var bNearGood = false;
var bFarGood = false;
var bStoreGood = false;
/*
* Error texts.
*/
var ErrorPhase = "Unknown";
var StoreErrText = "";

/*
* Check that we managed to start the production application program.
*/
if( started )
{
	ECode = 0;
	/*
	* Any form data ?
	* No form data indicates a window refresh.
	*/
	if ( Request.Form.Count > 0 )
	{
		/*
		* Extract image mode from URL
		* (near Visual, far Visual).
		*/
		if ( Request.Form("imgMode") != "" ) {
			imgMode = Request.Form("imgMode");
		}

		/*
		* Extract success flags.
		*/
		if ( Request.Form("initGood") == "true" ) {
			bInitGood = true;
		}
		if ( Request.Form("nearGood") == "true" ) {
			bNearGood = true;
		}

		if ( Request.Form("farGood") == "true" ) {
			bFarGood = true;
		}

		if ( Request.Form("storeGood") == "true" ) {
			bStoreGood = true;
		}

		/*
		* Extract image filenames from URL
		*/
		if ( Request.Form("visNearFile") != "" ) {
			visNearFile = Request.Form("visNearFile");
		}
		if ( Request.Form("visFarFile") != "" ) {
			visFarFile = Request.Form("visFarFile");
		}

		/*
		* Extract focus positions and distances.
		*/
		if ( Request.Form("nearDistance") != "" ) {
			nearDistance = toDecPoint( Request.Form("nearDistance") );
		}
		if ( Request.Form("farDistance") != "" ) {
			farDistance = toDecPoint( Request.Form("farDistance") );
		}

		/*
		* Decode the command.
		*/
		if ( Request.Form("measure") != "" )
		{
			getNewVisualImage( imgMode );

			// Perform a laserNear or laserFar operation.
			// Have we performed a init command yet ?
			if( !bInitGood )
			{
				ECode = executeCommand( "alignInit" );
				if( ECode != 0 )
				{
					bInitGood = false;
					bInitError = true;
				}
				else {
					ECode = executeCommand( "laserInit" );
					if( ECode != 0 ) {
						bInitGood = false;
						bInitError = true;
					}
					else {
						bInitGood = true;
						bInitError = false;
					}
				}
			}
			if( bInitGood )
			{
				if( imgMode == "Near" )
				{
					restree.setResourceValue("prod.syscalib.cmdargAlign.distance", nearDistance);
					ECode = executeCommand( "laserNear" );
					if( ECode != 0 )
					{
						bNearGood = false;
						bNearError = true;
					}
					else
					{
						bNearGood = true;
						bNearError = false;
					}
				}
				else if ( imgMode == "Far" )
				{
					restree.setResourceValue("prod.syscalib.cmdargAlign.distance", farDistance);
					ECode = executeCommand( "laserFar" );
					if( ECode != 0 )
					{
						bFarGood = false;
						bFarError = true;
					}
					else
					{
						bFarGood = true;
						bFarError = false;
					}
				}
			}
		}
		else if ( Request.Form("save") != "" )
		{
			// Have we performed init, near and far commands yet ?
			if( bInitGood && bNearGood && bFarGood )
			{
				ECode = executeCommand( "laserStore" );
				if( ECode != 0 )
				{
					bStoreGood = false;
					bStoreError = true;
				}
				else
				{
					bStoreGood = true;
					bStoreError = false;
				}
			}
			else
			{
				bStoreError = true;
				bStoreGood = false;
				if( !bNearGood )
					StoreErrText = "No Near measurement found";
				else if( !bFarGood )
					StoreErrText = "No Far measurement found";
			}
		}
	}
	// Remember which calculation phase that went wrong.
	if( bInitError )
		ErrorPhase = "Initialise";
	else if( bNearError )
		ErrorPhase = "Near";
	else if( bFarError )
		ErrorPhase = "Far";
	else if( bStoreError )
		ErrorPhase = "Save";
	else
		ErrorPhase = "Unknown";

	if( imgMode == "Near" )
		presFile = visNearFile;
	else
		presFile = visFarFile;

}
var strTitle = "Laser Calibration"; 
%>
  <html>
    <head>
      <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
      <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">

<!--
  *****************************************************************
  Client side Javascript code to deal with image selection etc.
  *****************************************************************
-->

<SCRIPT type="text/javascript">


  var imgMode = "<%Response.Write( imgMode );%>";
  var visNearFile = "<%Response.Write( visNearFile );%>";
  var visFarFile = "<%Response.Write( visFarFile );%>";
  var presentImage = "";
  var WinWidth = <%Response.Write( winWidth );%>;
  var WinHeight = <%Response.Write( winHeight );%>;

  /*
   * Switch to another image. (visualNear or visualFar).
   */
  function selectImage()
  {
    presentImage = document.getElementById( "imgMode" ).value;
    if( presentImage == "Near" )
    {
      document.getElementById("imgBmp").src = visNearFile;
      document.getElementById("imgBmp").width = WinWidth;
      document.getElementById("imgBmp").height = WinHeight;
      imgMode = "Near";
    }
    else if( presentImage == "Far" )
    {
      document.getElementById("imgBmp").src = visFarFile;
      document.getElementById("imgBmp").width = WinWidth;
      document.getElementById("imgBmp").height = WinHeight;
      imgMode = "Far";
    }
  }

  /*
   * Show the image in the window according to present state.
   * Update onscreen position indicators.
   */
  function initPage()
  {
    selectImage();
  }

  /*
   * Update hidden fields in the forms before submitting the data to the web server.
   * This transfers information from client side JavaScript to server side Jscript.
   */
  function onSubmitFunc()
  {
    return true;
  }

</SCRIPT>

      <STYLE type="text/css">
        #imgBmpClipDiv {
          position: absolute;
          left: auto; top: auto;
          height: auto;
          width: auto;
          overflow: hidden;
          z-index: 1;
        }
      </STYLE>
    </head>
    <body id="pgLaserCalib" OnLoad="initPage()">
      <%printStandardDecoration( strTitle );%>
      <%printNavigation( "mnuFocus", "mnuFocusLaser" );%>
      <!-- This is the actual contents -->
      <div id="mainpane">
        <div id="content">
          <TABLE WIDTH="<%Response.Write( winWidth + 350 );%>">
            <TR>
              <TD VALIGN="top" WIDTH="<%Response.Write( winWidth + 20 );%>" HEIGHT="<%Response.Write( winHeight + 10 );%>" >
                <div id="imgBmpClipDiv">
                  <img name="imgBmp" id="imgBmp" src="<%Response.Write( presFile );%>" width="<%Response.Write( winWidth );%>" height="<%Response.Write( winHeight );%>">
                </div>
              </TD>
              <TD VALIGN="top" >
                <h2>Instruction</h2>
<%//Response.Write( "<p>ECode:" + ECode + " ErrorPhase:" + ErrorPhase + "</p>\n" );%>
<%//Response.Write( "<p>initError:" + bInitError + " nearError:" + bNearError + " farError:" + bFarError + " storeError:" + bStoreError + "</p>\n" );%>
<%//Response.Write( "<p>initGood:" + bInitGood + " nearGood:" + bNearGood + " farGood:" + bFarGood + " storeGood:" + bStoreGood + "</p>\n" );%>
                <p>Activate the laser and point the camera at the <b>Near</b> target.</p>
                <p>Select <b>Near Distance</b> and press <b>Measure</b> to
                detect the laser position.</p> <p>Use a white wall or similar as target</p>
                <p>Point the camera at the <b>Far</b> target.<br>
                Select <b>Far Distance</b> and press <b>Measure</b> again
                to detect the laser position at the <b>Far</b> target.</p>
                <p>The <b>Near</b> and/or <b>Far</b> measurements can be repeated if needed.</p>
                <p>Fill in the <b>Near</b> and <b>Far</b> distances.</p>
                <p>Press <b>Save</b> to save the new laser calibration.</p>

                <%if( ECode > 0 )
                  {
                    Response.Write("<b>Error in " + ErrorPhase + " stage</b><br>");
                    Response.Write("<span id=errstatus>" + ecodeString( ECode ) + "</span>&nbsp;");
                    if ( strPrompt != "" ) Response.Write("<br>" + strPrompt);
                  }
                  else if( ECode < 0 )
                    Response.Write("<span id=errstatus> Production Application not available!</span>&nbsp;");
                  else if( Request.Form.Count > 0 )
                  {
                    if( !bInitError && !bNearError && !bFarError && !bStoreError )
                      Response.Write("<span id=OKstatus> Command OK </span>&nbsp;");
                    else
                    {
                      if( bStoreError && StoreErrText != "" )
                        Response.Write("<span id=errstatus>" + StoreErrText + "</span><br>");
                      else
                        Response.Write("<span id=errstatus>Error in " + ErrorPhase + " stage</span><br>");
                    }
                  }
                %>
              </TD>
            </TR>
          </TABLE>
          <TABLE ID="Table2" width="550">
            <tr>
              <form action="#" method="post" name="imagehandling" id="imagehandling" OnSubmit="return onSubmitFunc();">
                <td valign="top">
                  <table height="30" width="300" cellspacing="4" align="left">
                    <tr>
                      <td>
                        <select name="imgMode" id="imgMode" onChange="selectImage()">
                          <option value="Near"<% if( imgMode == "Near" ) Response.Write( " selected" ); %>>Near Distance</option>
                          <option value="Far"<% if( imgMode == "Far" ) Response.Write( " selected" ); %>>Far Distance</option>
                        </select>
                      </td>
                      <td>
                        <INPUT TYPE="submit" VALUE="Measure" ID="measure" NAME="measure">
                      </td>
                      <td>
                        <INPUT TYPE="submit" VALUE="Save" ID="save" NAME="save">
                      </td>
                    </tr>
                  </table>
                </td>
              </tr>
              <tr>
                <td>
                  <table width="550" height="30">
                    <tr>
                      <td valign="top">
                        <h3>Near distance&nbsp;&nbsp;</h3>
                      </td>
                      <td valign="top">
                        <input type="text" name="nearDistance" id="nearDistance" size="6" value="<%Response.Write( nearDistance );%>"> m
                      </td>
                      <td valign="top">
                        <h3>Far distance&nbsp;&nbsp;</h3>
                      </td>
                      <td valign="top">
                        <input type="text" name="farDistance" id="farDistance" size="6" value="<%Response.Write( farDistance );%>"> m
                      </td>
                    </tr>
                  </table>
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( visNearFile );%>" NAME="visNearFile" ID="visNearFile">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( visFarFile );%>" NAME="visFarFile" ID="visFarFile">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bInitGood ? "true" : "false" );%>" NAME="initGood" ID="initGood">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bNearGood ? "true" : "false" );%>" NAME="nearGood" ID="nearGood">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bFarGood ? "true" : "false" );%>" NAME="farGood" ID="farGood">
                  <INPUT TYPE="hidden" VALUE="<%Response.Write( bStoreGood ? "true" : "false" );%>" NAME="storeGood" ID="storeGood">
                </td>
              </form>
            </tr>
          </TABLE>
        </div>
        <%printStandardFooter();%>
      </div>
      <!-- End of actual contents -->
    </body>
  </html>
