<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%

  //
  // Create find the current range description.
  //
  function findDescr( rTree ) {
    var presRange, descr, TMax, TMin;
	
	if ( CamType != "G")
	{
	  descr = restree.getResourceValue( restree.getResourceValue(".image.ccase.ccase") + ".descr");
	}
	else
	{
		rTree.path = "";
		presRange = rTree.getResourceValue( "image.services.TMax.arrayIndex" );
		rTree.path = "calib.detector.iTimeScaling.userTable." + presRange;
		TMax = -273.15 + rTree.getResourceValue( "TMax" );
		TMin = -273.13 + rTree.getResourceValue( "TMin" );
		descr = " " + TMin.toFixed(0) + " - " + TMax.toFixed(0) + "C (" + rTree.getResourceValue( "ds" ) + ")"
	    rTree.path = "";
	}

    return descr;
  }
  var started = false;
  var enabled = false;
  var Ecode = 0;
      
  if (restree.getResourceValue( "prod.log.status" ) == "ready")
    started = true;

  if( Request.Form.Count > 0 ) {
    if( Request.Form( "mode" ) == "readWarm" ) {
      enabled = true;
      /*
       * Start the production application, unless already done
       */
      if( !started ) {
        restree.setResourceValue( "appl.supv.exec",  "prodapp" );
        for( i = 0; i < 100; i++ ) {
          if (restree.getResourceValue( "prod.log.status" ) == "ready")
          {
            started = true;
            break;
          }
          restree.sleep( 300 );
        }
      }
      if( started ) {
        //
        // Read warm image. Store the file on the ram disk.
        //
        restree.setResourceValue( "prod.map.command", "init" );
        i = 50;
        while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
          restree.sleep( 300 );

        //
        // Check if "init" command succeeded.
        //
        if( restree.getResourceValue( "prod.map.status" ) == "ready" ) {
          restree.setResourceValue( "prod.map.warmImage", "/Temp/warm.fff" );

		var RadiometricModel = ""
		RadiometricModel = restree.getResourceValue( ".caps.config.image.flow.radiometrics.model" );

		if( CamType == "A2" || CamType == "Pt" ) {
              restree.setResourceValue( "image.flow.maps.gainMap.apf.enabled", false );
              restree.setResourceValue( "system.focus.distance", 60.0 );
              restree.sleep( 1000 );
              restree.setResourceValue( "prod.map.command", "measWarmImageMp" );
              restree.setResourceValue( "image.flow.maps.gainMap.apf.enabled", true );
          }
          else if ( CamType == "E" || CamType == "A" || CamType == "X2" || CamType == "E2" || ( CamType == "E3" && RadiometricModel == "TECless" ))
              restree.setResourceValue( "prod.map.command", "measWarmImageMp" );
          else
              restree.setResourceValue( "prod.map.command", "measWarmImage" );
          
          i = 50;
          while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
            restree.sleep( 300 );
        }
        //
        // Return error code of last command.
        //
        Ecode = restree.getResourceValue( "prod.map.ecode" );
      }
    }
  }

  var strTitle = "Gain Mapping, Cold Image";
  var strCurrentDescr = findDescr(restree);
  var strNextPage; if ( CamType == "G" ) strNextPage = "GainMapCalcGF.asp"; else strNextPage = "GainMapCalc.asp";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMapCold" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
              <b>Create cold image</b>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION="<%Response.Write(strNextPage);%>" METHOD="POST">
                      <BR>
                      <BR>
                      <BR>
                      <INPUT TYPE="hidden" NAME="mode" VALUE="readCold">
                      <INPUT TYPE="submit" NAME="readCold" VALUE="Read Cold Image"<%if( !enabled || Ecode != 0 ) Response.Write( " disabled" );%>>
                    </FORM>
                    <BR>
                  </TD>
                  <TD VALIGN="top">
                    <%
                      if( enabled ) {
                        if( !started ) {
                          Response.Write( "Camera error : <span id=errstatus>Error starting production program</span>\n" );
                        }
                        else if( Ecode != 0 ) {
                          Response.Write( "Camera error : <span id=errstatus>" );
                          Response.Write( ecodeString( Ecode ) );
                          Response.Write( "</span>\n" );
                        }
                      }
                    %>
                    <p>For: <%Response.Write(strCurrentDescr);%></p>
                    <p>Point the camera at the cold blackbody<br>
                    and press the <b>Read Cold Image</b> button.</p>
                  </TD>
                </TR>
             </TABLE>
           </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
