<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/serviceutils.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%

//
// Find the active Gain Map, when subranges exist
//
function findCurGainMapName( rTree, resPathGM ) {
	var dblCurIntTimeUS, dblRefIntTimeUS, dblIntTimeUSDiff, dblLastIntTimeUSDiff;
	var child, lastChild, strGainMapName;

	rTree.path = "";
	strGainMapName = restree.getResourceValue( resPathGM + ".T.0.fileName" ); // Assumption

	// GF subranges?
	if ( restree.getResourceValue( resPathGM + ".TSFpaSubstitute" ) ==  ".image.flow.detector.ITimeUs" )
	{
		dblCurIntTimeUS = 1 * rTree.getResourceValue( "image.services.TMax.ITimeUs" );

		rTree.path = resPathGM + ".T";
		child = rTree.getFirst();
		dblLastIntTimeUSDiff = 100000;
		lastChild = "";

		while( child != "" ) {
			dblRefIntTimeUS = 1 * rTree.getResourceValue( child + ".TSFpaRaw" );
			dblIntTimeUSDiff = Math.abs(dblCurIntTimeUS - dblRefIntTimeUS);

			if (dblIntTimeUSDiff > dblLastIntTimeUSDiff)
				child = "";
			else
			{
				dblLastIntTimeUSDiff = dblIntTimeUSDiff;
				lastChild = child;
				child = rTree.getNext();
			}
		}
		child = lastChild;
		strGainMapName = restree.getResourceValue( child + ".fileName" ) + " ("+child+")"; 
	}
	rTree.path = "";
	return strGainMapName;
}


var started = false;
var calcMapName = "None";
var dpxMapName = "None";
var method;
var enabled = false;
var Ecode = 0;
var bCalibSaved = false;
var bSaveDeadMap = false;
var strCaseIndex = "";

if (restree.getResourceValue( "prod.log.status" ) == "ready")
started = true;

var strPresGainMap = restree.getResourceValue( "image.ccase.staticGainMap" );
if (strPresGainMap != "FAILED")  // Static map camera?
strPresGainMap = restree.getResourceValue( strPresGainMap + ".fileName" );
else                            
{                                // P-type camera, or GF
	strPresGainMap = findCurGainMapName( restree, restree.getResourceValue( "image.ccase.gainMap" ));
}

if( Request.Form.Count > 0 ) {
	if( Request.Form( "mode" ) == "calcMap" ) {
		enabled = true;
		/*
		* Start the production application, unless already done
		*/
		if( !started ) {
			restree.setResourceValue( "appl.supv.exec",  "prodapp" );
			for( i = 0; i < 50; i++ ) {
				if (restree.getResourceValue( "prod.log.status" ) == "ready")
				{
					started = true;
					break;
				}
				restree.sleep( 300 );
			}
		}
		if( started )
		{
			var strPresDeadMap = restree.getResourceValue( "image.ccase.deadPixMap" );
			strPresDeadMap = restree.getResourceValue( strPresDeadMap + ".fileName" );

			var strDeadPixStorage = restree.getResourceValue("prod.prodSpec.map.config.deadPixStorage");
			bSaveDeadMap = (strPresGainMap == strPresDeadMap || 
				Request.Form("dpxLocation") == "inGainMap" || 
				strDeadPixStorage == "inGainMap"); // See below...


			//
			// Calculate a gain map using previously stored
			// cold and warm images on the ram disk.
			//
			method = Request.Form( "method" );

			//
			// Check if "init" command succeeded.
			//
			restree.setResourceValue( "prod.map.coldImage", "/Temp/cold.fff" );
			restree.setResourceValue( "prod.map.warmImage", "/Temp/warm.fff" );

			restree.setResourceValue("prod.map.nameType", method);
			restree.setResourceValue("prod.map.command", "makeMapInfo");
			i = 50;
			while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
				restree.sleep( 300 );
			var EcodeTmp = restree.getResourceValue( "prod.map.ecode" );
			if ( Ecode == 0 )
				Ecode = EcodeTmp;

			calcMapName = restree.getResourceValue( "prod.map.gainMap" );

			if( Ecode == 0 ) {
				if ( bSaveDeadMap )
				{
					restree.setResourceValue("prod.map.deadMap", calcMapName);
					restree.setResourceValue( "image.flow.maps.deadPixMap.fillValue", 32768 );
				}

				restree.setResourceValue( "prod.map.command", "gainMap" );
				i = 50;
				while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
					restree.sleep( 300 );

				var EcodeTmp = restree.getResourceValue( "prod.map.ecode" );
				if ( Ecode == 0 )
					Ecode = EcodeTmp;

				restree.setResourceValue( "prod.map.command", "saveGainMap" );
				i = 50;
				while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
					restree.sleep( 300 );

				EcodeTmp = restree.getResourceValue( "prod.map.ecode" );
				if ( Ecode == 0 )
					Ecode = EcodeTmp;
			
				// Restart tcomp as a courtesy to operator
				restree.setResourceValue( "tcomp.active", true );

				if( bSaveDeadMap ) 
				{
					dpxMapName = restree.getResourceValue( "prod.map.deadMap" );
					// What this actually does, is to update the calib resources with a new dead map pointer.
					// It will, in this case, be a gain map name.
					restree.setResourceValue( "prod.map.command", "saveDeadMap" );
					i = 50;
					while (restree.getResourceValue( "prod.map.status" ) == "busy" && i-- > 0 )
						restree.sleep( 300 );

					EcodeTmp = restree.getResourceValue( "prod.map.ecode" );
					if ( Ecode == 0 )
						Ecode = EcodeTmp;
				}
				else
				{
					var mapPath = restree.getResourceValue( "image.ccase.deadPixMap" );
					mapPath += ".fileName";
					dpxMapName = restree.getResourceValue( mapPath );
				}

				//
				// Check if "gainMap" commands succeeded.
				//
				if( restree.getResourceValue( "prod.map.status" ) == "ready" && Ecode == 0 ) 
				{
					//
					// And save the calibration
					//
					restree.path = "";
					/*
					*/
					restree.setResourceValue( "prod.map.command", "saveCalib" ); 
					bCalibSaved = waitWhileBusy( "prod.map.status" );

					// Update the rest of the camera from the new calib file.

					{
						var strCCase = restree.getResourceValue(".image.ccase.ccase");
						strCaseIndex = strCCase.substr(13);
						restree.setResourceValue(".image.services.range.caseIndex", strCaseIndex);
						restree.setResourceValue(".image.services.range.commit", true);

						i = 50;
						while( restree.getResourceValue( ".image.services.range.status" ) != 0 && i-- > 0 )
							restree.sleep( 300 );

						if (CamType == "G" )
						{
							var arrayIndex = 0;
							var TMax = 0.0;
							arrayIndex = restree.getResourceValue( ".image.services.TMax.arrayIndex" );
							var zTmax = ".calib.detector.iTimeScaling.userTable." + arrayIndex.toFixed(0) + ".TMax";
							TMax = restree.getResourceValue( zTmax );
							restree.setResourceValue( ".image.services.TMax.TMax", TMax );
							restree.setResourceValue( ".image.services.TMax.commit", true );

							i = 50;
							while( restree.getResourceValue( ".image.services.TMax.status" ) != 0 && i-- > 0 )
								restree.sleep( 300 );
						}
					}
				}
			}
		}
	}
}
  // Read filename of selected gainmap from calibration.
  var strTitle = "Gain Mapping, Result";
  var strPixelsKilled = "";
  var strDeadMapName = "";
  var strCalibSaved = "";
  var strDpxMapInfo = "";

%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrGainMap" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
              <b>Map calculated</b>
              <BR>
              <BR>
              <%
                if( enabled ) {
                  if( !started ) {
                    Response.Write( "Camera error : <span id=errstatus>Error starting production program</span><BR><BR>\n" );
                  }
                  else if( Ecode != 0 ) {
                    Response.Write( "Camera error : <span id=errstatus>" );
                    Response.Write( ecodeString( Ecode ) );
                    Response.Write( "</span><BR><BR>\n" );
                  }
                  else
                  {
                    var nPixKilled = restree.getResourceValue( ".prod.map.pixKilled" );
                    if ( nPixKilled > 0 )
                      strPixelsKilled =  "Pixels killed&nbsp;&nbsp;:&nbsp;" + nPixKilled + ".<BR><BR>\n";
                  }
                  strDeadMapName = "Dead pixel map name is&nbsp;<B>" + dpxMapName + "</B>.<BR><br>\n";
                   
                  if( bCalibSaved ) 
                     strCalibSaved = "Calibration saved<BR><BR>\n"; 
                     
                  if (bSaveDeadMap)
                     strDpxMapInfo = '<p>Pixel replacement codes are stored in this gain map. You need to clean the image from bad pixels now. Please go to the <a href="pixkill.asp">pixel replacement</a> web page and run the "AfterGM_" methods.</p>'

                }
              %>
              Gain map&nbsp;<B><%Response.Write( calcMapName );%></B>&nbsp;written.<BR><BR>
              <%Response.Write( strPixelsKilled );%>
              <%Response.Write( strDeadMapName );%>
              <%Response.Write( strCalibSaved );%>
              <%Response.Write( strDpxMapInfo );%>
              
            </div>
			<%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
