<%@ LANGUAGE = JSCRIPT %>
<!-- #include virtual = "/inc/restree.inc" -->
<!-- #include virtual = "/inc/camtype.inc" -->
<!-- #include virtual = "/inc/sitewidgets.inc" -->
<!-- #include virtual = "/service/inc/servicemenu.inc" -->
<!-- #include virtual = "/service/inc/errorcodes.inc" -->
<%
  //
  // Create a calib case select tag.
  // The presently active calib case is preselected.
  //
  function caseSelector( rTree, name, nLines, extra ) {
    var casePath, presCase, fullPath, selTag;

    selTag = new SelectTag( name, nLines, extra );
    rTree.path = "";
    presCase = rTree.getResourceValue( "image.ccase.ccase" );
    rTree.path = "calib.ccase";
    casePath = rTree.getFirst();

    while( casePath != "" ) {
      fullPath = ".calib.ccase." + casePath;
      selTag.option( casePath, rTree.getResourceValue( casePath + ".descr" ), fullPath == presCase );
      casePath = rTree.getNext();
    }
    rTree.path = "";
    return selTag;
  }
  //
  // Create a range select tag.
  // The presently active range is preselected.
  //
  function rangeSelector( rTree, name, nLines, extra ) {
    var rangePath, presRange, fullPath, selTag, rangeCount, rangeDescr, TMax, TMaxKelvin, TMin;

    selTag = new SelectTag( name, nLines, extra );
    rTree.path = "";
    presRange = rTree.getResourceValue( "image.services.TMax.arrayIndex" );
    rTree.path = "calib.detector.iTimeScaling.userTable";
    rangePath = rTree.getFirst();
	rangeCount = 0;

    while( rangePath != "" ) {
      fullPath = ".calib.detector.iTimeScaling.userTable." + rangePath;
	  TMaxKelvin = rTree.getResourceValue( rangePath + ".TMax" );
	  TMax = -273.15 + TMaxKelvin;
	  TMin = -273.13 + rTree.getResourceValue( rangePath + ".TMin" );
	  rangeDescr = " " + TMin.toFixed(0) + " - " + TMax.toFixed(0) + "C (" + rTree.getResourceValue( rangePath + ".ds" ) + ")"
      selTag.option( TMaxKelvin, rangeDescr, rangeCount == presRange );
      rangePath = rTree.getNext();
	  rangeCount = rangeCount+1;
    }
    rTree.path = "";
    return selTag;
  }
  
  //
  // Find the active Gain Map, when subranges exist
  //
  function findCurGainMapName( rTree, resPathGM ) {
    var dblCurIntTimeUS, dblRefIntTimeUS, dblIntTimeUSDiff, dblLastIntTimeUSDiff;
	var child, lastChild, strGainMapName;

    rTree.path = "";
    strGainMapName = restree.getResourceValue( resPathGM + ".T.0.fileName" ); // Assumption
	
	// GF subranges?
	if ( restree.getResourceValue( resPathGM + ".TSFpaSubstitute" ) ==  ".image.flow.detector.ITimeUs" )
	{
	    dblCurIntTimeUS = 1 * rTree.getResourceValue( "image.services.TMax.ITimeUs" );
		
		rTree.path = resPathGM + ".T";
		child = rTree.getFirst();
		dblLastIntTimeUSDiff = 100000;
		lastChild = "";

		while( child != "" ) {
		  dblRefIntTimeUS = 1 * rTree.getResourceValue( child + ".TSFpaRaw" );
		  dblIntTimeUSDiff = Math.abs(dblCurIntTimeUS - dblRefIntTimeUS);
		  
		  if (dblIntTimeUSDiff > dblLastIntTimeUSDiff)
			child = "";
		  else
		  {
			dblLastIntTimeUSDiff = dblIntTimeUSDiff;
			lastChild = child;
			child = rTree.getNext();
		  }
		}
		child = lastChild;
		strGainMapName = restree.getResourceValue( child + ".fileName" ) + " ("+child+")"; 
	}
    rTree.path = "";
    return strGainMapName;
  }
  
  
  /* Main part of server side script */
  
  var caseIndex  = -1;

  if( Request.Form( "ccase" ) != "" ) 
  {
    //
    // Activate selected calib case.
    //
    caseIndex = Request.Form( "ccase" )
    restree.setResourceValue( "image.services.range.caseIndex", caseIndex );
    restree.res.SetBoolValueWait( "image.services.range.commit", 1 );
    for( i = 0; i < 50; i++ ) 
    {
        if( restree.getResourceValue( "image.services.range.status" ) == 0 )
            break;

        restree.sleep( 300 );
    }
  }
  
  var rangeTMax = -273.15;

  if( Request.Form( "range" ) != "" ) 
  {
    //
    // Activate selected range.
    //
    rangeTMax = Request.Form( "range" )
    restree.setResourceValue( "image.services.TMax.TMax", rangeTMax);
    restree.res.SetBoolValueWait( "image.services.TMax.commit", 1 );
    for( i = 0; i < 50; i++ ) 
    {
        if( restree.getResourceValue( "image.services.TMax.status" ) == 0 )
            break;

        restree.sleep( 300 );
    }
  }

  

  var selectTag, strCaseOrRange;
  if ( CamType == "G" )
  {
	selectTag = rangeSelector( restree, "range", 1, "" ); strCaseOrRange = "range";
  }
  else
  {
	selectTag = caseSelector( restree, "ccase", 1, "" ); strCaseOrRange = "case";
  }
  var strTitle = "Image Correction, Select " + strCaseOrRange;
  
  // Read filename of selected maps from calibration.
  var strPresDeadMap = restree.getResourceValue( "image.ccase.deadPixMap" );
  strPresDeadMap = restree.getResourceValue( strPresDeadMap + ".fileName" );
  var strPresGainMap = restree.getResourceValue( "image.ccase.staticGainMap" );
  if (strPresGainMap != "FAILED" && strPresGainMap != "<no match>" )  // Static map camera?
    strPresGainMap = restree.getResourceValue( strPresGainMap + ".fileName");
  else                            
  {                                // P-type camera, or GF
	 strPresGainMap = findCurGainMapName( restree, restree.getResourceValue( "image.ccase.gainMap" )  )
  }
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - " + CamFamily + " Service Web");%></title>
        <LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">
    <body id="pgImgCorrGainMap">
        <%printStandardDecoration( strTitle );%>
        <%printNavigation( "mnuImgCorr", "mnuImgCorrSelCase" );%>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
              <b>Select <%Response.Write(strCaseOrRange);%></b>
              <TABLE>
                <TR>
                  <TD VALIGN="top">
                    <BR>
                    <BR>
                    <FORM ACTION=# METHOD="POST">
                      <%selectTag.print();%>
                      <BR>
                      <BR>
                      <BR>
                      <INPUT TYPE="submit" NAME="setUp" VALUE="Change <%Response.Write(strCaseOrRange);%>">
                    </FORM>
                    <BR>
                    <u>Current maps</u><br><br>
                    &nbsp;&nbsp;Gain map: <b><%Response.Write( strPresGainMap );%></b><BR>
                    &nbsp;&nbsp;Dead pixel map: <b><%Response.Write( strPresDeadMap );%></b><BR>
                  </TD>
                </TR>
             </TABLE>
            </div>
            <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>

