
<%
function PrintAccProtocol( )
{
	restree.path = "calib.ccase";
	var restreeProt = new ResTree();
	var restreeMpnt = new ResTree();
    var restreeLens = new ResTree();
	var strRemark;

	var protDate, protLocation, protOperator, protRoomTemp, protRelHum;
	var strLensSN;
	
	restreeLens.path = "calib.lens";
	var lensItem = restreeLens.getFirst();
	var nLensCount = 0;
	
	while (lensItem != "")
	{
		if ( lensItem != "le" )
		{
		    if (nLensCount == 0)
		    {
		        Response.Write("<TABLE>\n");
		        Response.Write("<TR><TD align='left' width='150'>Lense(s):</TD><TD align='left' width='340'>Serial:</TD></TR>\n");
		    }
		    
		    strLensSN = restreeLens.getResourceValue(lensItem + ".SN");
		    
		    if (strLensSN == "")
		        strLensSN = "-";
		    
		    nLensCount++;
		    Response.Write("<TR><TD align='left' width='150'>&nbsp;&nbsp;" + restreeLens.getResourceValue(lensItem + ".descr") + "</TD><TD align='left' width='340'>&nbsp;&nbsp;" + strLensSN + "</TD></TR>\n");
		    
		}
		lensItem = restreeLens.getNext();
	}
	if (nLensCount > 0)
		Response.Write("</TABLE><BR>\n");
	
	var CCaseItem = restree.getFirst();
	
	while (CCaseItem != "")
	{
		var strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		var strCaseID = restree.getResourceValue(CCaseItem + ".ID");
        restreeProt.path = "calib.extRBFCalc.curData.aProt." + strCaseID;
    
		var bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		  
		if ( bCaseEnabled )
		{
        var calibType = restreeProt.getResourceValue("type");
        if ( calibType != "FAILED" )
        {
          
		  Response.Write("<TABLE><CAPTION align='left'><u>" + strCaseDescr + "</u></CAPTION>\n");
          Response.Write( '<TR><TD vAlign="top" width="150">True Temperature</TD>\n' );
          Response.Write( '    <TD vAlign="top" width="150">Camera Temp.</TD>\n' );
          Response.Write( '    <TD vAlign="top" width="150">Difference</TD>\n' );
          Response.Write( '    <TD vAlign="top" width="150">Emissivity</TD>\n' );
          if( calibType  >= 300 ) {
				Response.Write( '    <TD vAlign="top" width="150">TMin-TMax</TD>\n' );
		  }
		  Response.Write( '    <TD vAlign="top" width="150">Status</TD>\n  </TR>\n' );
          
          restreeMpnt.path = restreeProt.path + ".aMpnt";
          var mpntItem = restreeMpnt.getFirst();  // Traverses measurements
          //
          // For all measurements in this calib case.
          //
          while( mpntItem != "" ) 
          {
			camTMax = "";
            bbTemp = restreeMpnt.getResourceValue( mpntItem + ".trueT" ) - 273.15;
            camTemp = restreeMpnt.getResourceValue( mpntItem + ".camT" ) - 273.15;
            camEmiss = restreeMpnt.getResourceValue( mpntItem + ".emissivity" );
            //
            // Remark strings is only avaliable if type > 100.
            //
            if( calibType > 100 ) {
              camRemark =  restreeMpnt.getResourceValue( mpntItem + ".remark" );
              camError = restreeMpnt.getResourceValue( mpntItem + ".TError" );
	            if( calibType  >= 300 ) {
					camTMax =  restreeMpnt.getResourceValue( mpntItem + ".TMax" );
				}
            }
            else {
              camRemark = "&nbsp;";
              camError = camTemp - bbTemp;
              if (bbTemp > 100.0)
                camError = (camError/bbTemp*100.0); // Convert to relative error
            }
            //
            // Report error in % if blackbody temperature > 100 C.
            camUnit = "";
            if( bbTemp > 100.0 ) {
              camUnit = "&nbsp;%";
            }
            else {
              camUnit = "&nbsp;&deg;C";
            }
            Response.Write( '  <TR>\n    <TD vAlign="top" width="150">' + bbTemp.toFixed(2) +'</TD>\n' );
            Response.Write( '    <TD vAlign="top" width="150">' + camTemp.toFixed(2) + '</TD>\n' );
            Response.Write( '    <TD vAlign="top" width="150">' + camError.toFixed(2) + camUnit + '</TD>\n' );
            Response.Write( '    <TD vAlign="top" width="150">' + camEmiss.toFixed(3) + '</TD>\n' );
            if( calibType  >= 300 ) {
	            Response.Write( '    <TD vAlign="top" width="150">' + camTMax + '</TD>\n' );
			}
            Response.Write( '    <TD vAlign="top" width="150">' + camRemark + '</TD>\n  </TR>\n' );
            mpntItem = restreeMpnt.getNext();  // Next measurement.
          }
          protDate = restreeProt.getResourceValue( "date" );
          protLocation = restreeProt.getResourceValue( "location" );
          protOperator = restreeProt.getResourceValue( "operator" );
          protRoomTemp = restreeProt.getResourceValue( "TAmbient" )-273.15;
          protRelHum =   100.0*restreeProt.getResourceValue( "humidity" );
          var fDist = 1.0*restreeProt.getResourceValue("distance");
          var fCollimTransm = 1.0*restreeProt.getResourceValue("collimTransm");
          
          Response.Write("<TR><TD COLSPAN=5>Room temperature " + protRoomTemp.toFixed(1) + "&nbsp;&deg;C, humidity " + protRelHum.toFixed(0) + "%, distance " + fDist.toFixed(2) + " m.\n" );
          if (fCollimTransm != 1.0 && fCollimTransm != 0.0)
            Response.Write("Collimator reflectance " + fCollimTransm.toFixed(3) + "." );
          Response.Write("</TD></TR>\n" );	  	  
	  	  Response.Write("<TR><TD COLSPAN=5>Checked " + protDate + " in " + protLocation + " by " + protOperator + ".</TD></TR>\n");
          Response.Write("</TABLE><BR>\n");
        }
		    else
		    {
		      //Response.Write("<TABLE><CAPTION align='left'><u>" + strCaseDescr + "</u>&nbsp;</CAPTION>\n");
		      //Response.Write('<TR><TD width="300">No measurements</TD></TR>\n<br>\n');
          //Response.Write("</TABLE><BR>");
		    }
      }

			restree.setCurrent(CCaseItem);
			CCaseItem = restree.getNext();
	}
	restree.path = "";
}
//
// Start of main code.
//

//
// Read various version resources displayed in the protocol header.
//
  
  var bBeingRecalibrated = true;
  restree.path = "calib.extRBFCalc.recalData.cProt";

  if (restree.getFirst() == "")
    bBeingRecalibrated = false;
  
  restree.path = "";
  var calVersion = "Being recalibrated";
  if (!bBeingRecalibrated) 
      calVersion = restree.getResourceValue( "calib.general.calibStage" );
  var camType = restree.getResourceValue( "version.product.name" );
  var camSerial = restree.getResourceValue( "version.product.serial" );
  if (camSerial == "*") camSerial = restree.getResourceValue( "version.hw.camcore.serial" );
  var camArticle = restree.getResourceValue( "version.product.article" );
  var camDate = restree.getResourceValue( "version.product.date" );
  var detSerial = restree.getResourceValue( "version.hw.detector.serial" );
  var swVersion = restree.getResourceValue( "version.kits.appkit.ver" );

  if (Request.QueryString("simple") != "")
    bSimple = true;
    
  var strTitle = "Accuracy Protocol";
%>
<html>
    <head>
        <title><%Response.Write(strTitle + " - Serial " + camSerial + " - " + CamFamily + " Service Web");%></title>
        <%if (!bSimple)
            Response.Write('<LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">');
        %>
    </head>
    <body>
        <%printStandardDecoration( strTitle );%>
        <%
          if (!bSimple)
            printNavigation( strMenu, strMenuItem );
        %>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <% if (!bSimple)
                  Response.Write('<div id="contentprintinstr"><a href="' + strOrigFile + '?simple=true">Printer-friendly format</a><br><br></div>');
                %>
                <TABLE>
                    <TR>
                        <TD align="left" width="25%">Camera type :</TD>
                        <TD align="left" width="171"><%Response.Write( camType );%></TD>
                        <TD align="left" width="25%">Product code :</TD>
                        <TD align="left" width="25%"><%Response.Write( camArticle );%></TD>
                    </TR>
                    <TR>
                        <TD align="left" width="25%">Camera serial :</TD>
                        <TD align="left" width="171"><%Response.Write( camSerial );%></TD>
                        <TD align="left" width="25%">Manuf. date :</TD>
                        <TD align="left" width="25%"><%Response.Write( camDate );%></TD>
                    </TR>
                    <TR>
                        <TD align="left" width="25%">Det. serial :</TD>
                        <TD align="left" width="171"><%Response.Write( detSerial );%></TD>
                        <TD align="left" width="25%">SW version :</TD>
                        <TD align="left" width="25%"><%Response.Write( swVersion );%></TD>
                    </TR>
                    <TR>
                        <TD width="25%">Calib version :</TD>
                        <TD width="171"><%Response.Write( calVersion );%></TD>
                        <TD align="left" width="25%"></TD>
                        <TD align="left" width="25%"></TD>
                    </TR>
                </TABLE>
                <BR>
                <%PrintAccProtocol();%>
                <BR>
            </div>
            <% if (!bSimple)
              printStandardFooter();
            %>
        </div>
        <!-- End of actual contents -->
    </body>
</html>
