<%

function PrintCalibProtocol( bShowAllCases, bShowPoints )
{
		restree.path = "calib.ccase";
	    var restreeRBF = new ResTree();
	    var restreeProt = new ResTree();
	    var restreeMpnt = new ResTree();
		var fRval, fBval, fFval, fJ0val, fF1val, fAdErrval;
		var strRemark;
		var strLocks;
		var nCases = 0;
		var protDate, protLocation, protOperator; 
		var strLensSN;
		

		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseSelected = restree.getResourceValue(CCaseItem + ".recalibSel");
		  
		  if (bCaseSelected || bShowAllCases )
		  {
		    nCases++;
		    Response.Write("<TABLE><CAPTION align='left'><u>" + strCaseDescr + "</u></CAPTION>\n");
		    
		    bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		    if ( bCaseEnabled )
		    {
		      restreeRBF.path = "calib.extRBFCalc.recalData.RBFCache";
		      restreeProt.path = "calib.extRBFCalc.recalData.cProt";
		      
		      fRval = restreeRBF.getResourceValue(strCaseID + ".R");
		      if ( fRval == "FAILED")
		      {
		        restreeRBF.path = "calib.extRBF";
		        fRval = restreeRBF.getResourceValue(strCaseID + ".R");
		        restreeProt.path = "calib.extRBFCalc.curData.cProt";
		      }
		      if ( fRval != "FAILED" && 1*fRval >= 0  )
		      {
		        Response.Write("<TR><TD vAlign='top' width='198'>Constants:<br>\n");
		        Response.Write("&nbsp;&nbsp;R:  " + fRval.toFixed(1) + "<br>\n");		      
		        fBval = restreeRBF.getResourceValue(strCaseID + ".B");
		        Response.Write("&nbsp;&nbsp;B:  " + fBval.toFixed(2) + "<br>\n");		      
		        fFval = restreeRBF.getResourceValue(strCaseID + ".F");
		        Response.Write("&nbsp;&nbsp;F:  " + fFval.toFixed(2) + "<br>\n");		      
		        fJ0val = restreeRBF.getResourceValue(strCaseID + ".J0");
		        Response.Write("&nbsp;&nbsp;J0: " + fJ0val.toFixed(1) + "<br>\n");		      
		        fJ1val = restreeRBF.getResourceValue(strCaseID + ".J1");
		        Response.Write("&nbsp;&nbsp;J1: " + fJ1val.toFixed(2) + "<br>\n");		      
		        fAdErrval = restreeProt.getResourceValue(strCaseID + ".adErr");
		        if ( fAdErrval != "FAILED" )
		        {
		          Response.Write("&nbsp;&nbsp;AdErr: " + fAdErrval.toFixed(5) + "<br>\n");		      
		          strLocks = restreeProt.getResourceValue(strCaseID + ".locks");
		          Response.Write("&nbsp;&nbsp;Locks: " + strLocks + "<br>\n");		      
		          strRemark = restreeProt.getResourceValue(strCaseID + ".remark");

		          var strSpanID = "";
		          if ( strRemark == "RBF OK" )
		            strSpanID = " id=OKstatus ";
		          else if ( strRemark[0] != '(' )
		            strSpanID = " id=errstatus ";
      		    
		          Response.Write("&nbsp;&nbsp;Rem: <span" + strSpanID + ">"+ strRemark + "</span><br>\n");
      		    
		          if (bShowPoints)
		          {
		            Response.Write("</TD>\n<TD vAlign='top' width='340'>Adaptation result:<br>\n");		      
        		    
		            restreeMpnt.path = restreeProt.path + "." + strCaseID + ".cMpnt";
        		    
		            var CMpntItem = restreeMpnt.getFirst();
		            var fTTrue, fObjSig, fTCalc, fTError, strErrUnit;
        		    
		            while (CMpntItem != "")
		            {
		              fTTrue = 1.0*restreeMpnt.getResourceValue(CMpntItem + ".trueT")-273.15;
		              fTCalc = 1.0*restreeMpnt.getResourceValue(CMpntItem + ".calcT")-273.15;
		              fTError = restreeMpnt.getResourceValue(CMpntItem + ".TError");
		              if (fTError == "FAILED")
		                fTError = restreeMpnt.getResourceValue(CMpntItem + ".Tdiff");
		                
		              if ( fTTrue > 100.0 )
		                 strErrUnit = "%"
		              else
		                 strErrUnit = "C"
		              
		              if (fTCalc > -200.0)
		                Response.Write("&nbsp;&nbsp;" + fTTrue.toFixed(2) + ":&nbsp;&nbsp;" + fTCalc.toFixed(2) + " (" + fTError.toFixed(2) + " " + strErrUnit + ")<BR>\n");
        		      
		              CMpntItem = restreeMpnt.getNext();
		            }
		          }
		          Response.Write("</TD>");
		        }
		        else
		          Response.Write("</TD>");
		          
		        Response.Write("</TR>\n");
                protDate = restreeProt.getResourceValue( strCaseID + ".date" );
                protLocation = restreeProt.getResourceValue( strCaseID + ".location" );
                protOperator = restreeProt.getResourceValue( strCaseID + ".operator" );
	  	        Response.Write("<TR><TD COLSPAN=2>Calibrated " + protDate + " in " + protLocation + " by " + protOperator + ".</TD></TR>\n");
		      }
		      else
		      {
		        Response.Write('<TR><TD width="300">No calibration</TD></TR>\n');
		      }
		      Response.Write("<br>\n");
		    }
		    else
		    {
		      Response.Write('<TR><TD width="300">Disabled</TD></TR>\n<br>\n');
		    }
        Response.Write("</TABLE><BR>");
		  }
			restree.setCurrent(CCaseItem);
			CCaseItem = restree.getNext();
		}
		restree.path = "";
		
		return nCases;
}

var bBeingRecalibrated = true;
restree.path = "calib.extRBFCalc.recalData.cProt";
var protCase = restree.getFirst();

if (protCase == "")
{
  restree.path = "calib.extRBFCalc.curData.cProt";
  protCase = restree.getFirst();
  bBeingRecalibrated = false;
}

restree.path = "";
var calVersion = "Being recalibrated";
if (!bBeingRecalibrated) 
    calVersion = restree.getResourceValue( ".calib.general.calibStage" );
var camType = restree.getResourceValue( "version.product.name" );
var camSerial = restree.getResourceValue( "version.product.serial" );
if (camSerial == "*") camSerial = restree.getResourceValue( "version.hw.camcore.serial" )
var camArticle = restree.getResourceValue( "version.product.article" );
var camDate = restree.getResourceValue( "version.product.date" );
var detSerial = restree.getResourceValue( "version.hw.detector.serial" );
var swVersion = restree.getResourceValue( "version.kits.appkit.ver" );

if (Request.QueryString("simple") != "")
   bSimple = true;
   
var strTitle = "Calibration Protocol";
   
%>

<html>  
    <head>
        <title><%Response.Write(strTitle + " - Serial " + camSerial + " - " + CamFamily + " Service Web");%></title>
        <%if (!bSimple)
            Response.Write('<LINK href="../../styles/flirweb.css" type="text/css" rel="stylesheet">');
        %>
    </head>
	  <body>
        <%printStandardDecoration( strTitle );%>
        <%
          if (!bSimple)
            printNavigation( strMenu, strMenuItem );
        %>
        <!-- This is the actual contents -->
        <div id="mainpane">
            <div id="content">
                <% if (!bSimple)
                  Response.Write('<div id="contentprintinstr"><a href="' + strOrigFile + '?simple=true">Printer-friendly format</a><br><br></div>');
                %>
               <TABLE ID="Table1">
                    <TR>
                        <TD align="left" width="25%">Camera type :</TD>
                        <TD align="left" width="171"><%Response.Write( camType );%></TD>
                        <TD align="left" width="25%">Product code :</TD>
                        <TD align="left" width="25%"><%Response.Write( camArticle );%></TD>
                    </TR>
                    <TR>
                        <TD align="left" width="25%">Serial :</TD>
                        <TD align="left" width="171"><%Response.Write( camSerial );%></TD>
                        <TD align="left" width="25%">Manuf. date :</TD>
                        <TD align="left" width="25%"><%Response.Write( camDate );%></TD>
                    </TR>
                    <TR>
                        <TD align="left" width="25%">Det. serial :</TD>
                        <TD align="left" width="171"><%Response.Write( detSerial );%></TD>
                        <TD align="left" width="25%">SW version :</TD>
                        <TD align="left" width="25%"><%Response.Write( swVersion );%></TD>
                    </TR>
                    <TR>
                        <TD align="left" width="25%">Calib version :</TD>
                        <TD align="left" width="171"><%Response.Write( calVersion );%></TD>
                        <TD align="left" width="25%"></TD>
                        <TD align="left" width="25%"></TD>
                    </TR>
                </TABLE>
                <BR>
                <% 
                    var restreeLens = new ResTree();
                    restreeLens.path = "calib.lens";
                    var lensItem = restreeLens.getFirst();
                    var nLensCount = 0;

                    while (lensItem != "")
                    {
                       if ( lensItem != "le" )
                       {
                          if (nLensCount == 0)
                          {
                             Response.Write("<TABLE>\n");
                             Response.Write("<TR><TD align='left' width='200'>Lense(s):</TD><TD align='left' width='340'>Serial:</TD></TR>\n");
                          }
                          
                          strLensSN = restreeLens.getResourceValue(lensItem + ".SN");
                          
                          if (strLensSN == "")
                             strLensSN = "-";
                          
                          nLensCount++;
                          Response.Write("<TR><TD align='left' width='200'>&nbsp;&nbsp;" + restreeLens.getResourceValue(lensItem + ".descr") + "</TD><TD align='left' width='340'>&nbsp;&nbsp;" + strLensSN + "</TD></TR>\n");
                          
                       }
                       lensItem = restreeLens.getNext();
                    }
                    if (nLensCount > 0)
                        Response.Write("</TABLE>\n");


                   var bProtoShown = false;
                   if (strOrigFile == "SysCalibProtocol.asp" )
                      bProtoShown = (PrintCalibProtocol(false,true) > 0);
                   if (!bProtoShown)
                      PrintCalibProtocol( true, true );
                 %>
            </div>
			      <%printStandardFooter();%>
        </div>
        <!-- End of actual contents -->
    </body>
</html>


