<%

function isAppStarted( strAppName, strResourceToTest )
{
  var started = false;
  
  var varType = restree.valueType( strResourceToTest );
  if( varType != "N/A") 
  {
    started = true;
  }
  if( started == false ) 
  {
    restree.setResourceValue( "appl.supv.exec",  strAppName );
    for( i = 0; i < 1000; i++ ) 
    {
        var varType = restree.valueType( strResourceToTest );
        if( varType != "N/A") 
        {
            started = true;
            break;
        }
     }
  }
  return started;
}

function waitWhileBusy( strResName )
{
  var waitResult = false;
  for( i = 0; i < 200; i++ ) 
  {
    restree.sleep(500);
    
    if( restree.getResourceValue( strResName  ) != "busy" ) 
    {
      waitResult = true;
      break;
    }
  }
  return waitResult;
}  

function convFromSelSepToTab( strIn )
{
  var str = new String(strIn);
  var arr = str.split(", ");
  var strOut = "";
  
  for( var i = 0; i < arr.length; i++ ) 
  {
    if ( i > 0 )
       strOut += "\t";
    strOut += arr[i];
  }
  return strOut;
}  

function evalRBFFlags(fRVal, nFlags)
{
	var strRBFText = "(No RBF)";
	
	if (nFlags != -1)
	{
    if (fRVal != 0)
    {
        if ((nFlags & 0x0000000F) != 0)
        {
          if ((nFlags & 0x00000002) != 0)
              strRBFText = "(Few points)";
          else if ((nFlags & 0x00000004) != 0)
              strRBFText = "(High aderr)";
          else if ((nFlags & 0x00000008) != 0)
              strRBFText = "(Bad accuracy)";
          else
              strRBFText = "(RBF error)";
        }
        else if ((nFlags & 0x00007F00) == 0x00001000)
          strRBFText = "(RBF OK)";
        else if ((nFlags & 0x00007F00) == 0x00002000)
          strRBFText = "(RBF 2P OK)";
        else if ((nFlags & 0x00007F00) == 0x00004000)
          strRBFText = "(Estimated)";
        else  
          strRBFText = "(Default RBF)"; 
    }
    else if ((nFlags & 0x00007F00) == 0x00000100)
        strRBFText = "(Cleared)"; 
    else if ((nFlags & 0x00007F00) == 0x00000200)
        strRBFText = "(Measuring)"; 
    else if ((nFlags & 0x00007F00) == 0x00000400)
        strRBFText = "(UnCalc)"; 
    else
    {
        if ((nFlags & 0x0000000F) != 0)
        {
          if ((nFlags & 0x00000002) != 0)
              strRBFText = "(Few points)";
          else if ((nFlags & 0x00000004) != 0)
              strRBFText = "(High aderr)";
          else
              strRBFText = "(RBF error)";
        }
        //else
          //strRBFText = "(No RBF)";  No RBF and no measurement collection in progress 
    }
  }
  return strRBFText;
}

function PrintCalibStatusInfo( bShowAllCases, bShowPoints )
{
		restree.path = "calib.ccase";
	  var restreeRBF = new ResTree();
	  var restreeProt = new ResTree();
	  var restreeMpnt = new ResTree();
		var fRval, fBval, fFval, fJ0val, fF1val, fAdErrval;
		var strLocks;
		var strRemark;
		var nCases = 0;

		var CCaseItem = restree.getFirst();
  	
		while (CCaseItem != "")
		{
		  strCaseDescr = restree.getResourceValue(CCaseItem + ".descr");
		  strCaseID = restree.getResourceValue(CCaseItem + ".ID");
		  bCaseSelected = restree.getResourceValue(CCaseItem + ".recalibSel");
		  
		  if (bCaseSelected || bShowAllCases )
		  {
		    Response.Write("<u>" + strCaseDescr + "</u><br>\n");
		    
		    bCaseEnabled = restree.getResourceValue(CCaseItem + ".enabled");
		    if ( bCaseEnabled )
		    {
		      restreeRBF.path = "calib.extRBFCalc.recalData.RBFCache";
		      restreeProt.path = "calib.extRBFCalc.recalData.cProt";
		      
		      fRval = restreeRBF.getResourceValue(strCaseID + ".R");
		      if ( fRval == "FAILED")
		      {
		        restreeRBF.path = "calib.extRBF";
		        fRval = restreeRBF.getResourceValue(strCaseID + ".R");
		        restreeProt.path = "calib.extRBFCalc.curData.cProt";
		      }
		      if ( fRval != "FAILED" && 1*fRval >= 0 )
		      {
		        nCases++;
		        Response.Write("R:  " + fRval.toFixed(1) + "<br>\n");		      
		        fBval = restreeRBF.getResourceValue(strCaseID + ".B");
		        Response.Write("B:  " + fBval.toFixed(2) + "<br>\n");		      
		        fFval = restreeRBF.getResourceValue(strCaseID + ".F");
		        Response.Write("F:  " + fFval.toFixed(2) + "<br>\n");		      
				if( CamType == "G" ) {
					fJ0val = restreeRBF.getResourceValue(strCaseID + ".J0");
					Response.Write("J0: " + fJ0val.toFixed(3) + "<br>\n");		      
					fJ1val = restreeRBF.getResourceValue(strCaseID + ".J1");
					Response.Write("J1: " + fJ1val.toFixed(3) + "<br>\n");		      
				}
				else {
					fJ0val = restreeRBF.getResourceValue(strCaseID + ".J0");
					Response.Write("J0: " + fJ0val.toFixed(1) + "<br>\n");		      
					fJ1val = restreeRBF.getResourceValue(strCaseID + ".J1");
					Response.Write("J1: " + fJ1val.toFixed(2) + "<br>\n");		      
				}
		        fAdErrval = restreeProt.getResourceValue(strCaseID + ".adErr");
		        if ( fAdErrval != "FAILED" )
		        {
		          Response.Write("AdErr: " + fAdErrval.toFixed(5) + "<br>\n");		      
		          strLocks = restreeProt.getResourceValue(strCaseID + ".locks");
		          Response.Write("Locks: " + strLocks + "<br>\n");		      
		          strRemark = restreeProt.getResourceValue(strCaseID + ".remark");

		          var strSpanID = "";
		          if ( strRemark == "RBF OK" )
		            strSpanID = " id=OKstatus ";
		          else if ( strRemark[0] != '(' )
		            strSpanID = " id=errstatus ";
      		    
		          Response.Write("Rem: <span" + strSpanID + ">"+ strRemark + "</span><br>\n");
      		    
		          if (bShowPoints)
		          {
		            Response.Write("<br>\n");		      
        		    
		            restreeMpnt.path = restreeProt.path + "." + strCaseID + ".cMpnt";
        		    
		            var CMpntItem = restreeMpnt.getFirst();
		            var fTTrue, fObjSig, fTCalc, fTError, strMpntRemark, strTTrue;
        		    
		            while (CMpntItem != "")
		            {
		              fTTrue = 1.0*restreeMpnt.getResourceValue(CMpntItem + ".trueT")-273.15;
		              if (fTTrue < -100.0)
		                strTTrue = restreeMpnt.getResourceValue(CMpntItem + ".BBTName");
		              else
		                strTTrue = fTTrue.toFixed(2);
      		            
		              fObjSig = restreeMpnt.getResourceValue(CMpntItem + ".objSig");
		              fTCalc = 1.0*restreeMpnt.getResourceValue(CMpntItem + ".calcT")-273.15;
		              fTError = restreeMpnt.getResourceValue(CMpntItem + ".TError");
		              if (fTError == "FAILED")
		                fTError = restreeMpnt.getResourceValue(CMpntItem + ".Tdiff");
		              strMpntRemark = restreeMpnt.getResourceValue(CMpntItem + ".remark");
	    			  if( CamType == "G" )
							Response.Write(strTTrue + ": " + fObjSig.toFixed(3) + " ");
		              else
							Response.Write(strTTrue + ": " + fObjSig.toFixed(1) + " ");
		              if (fTCalc > -200.0)
		                Response.Write( fTCalc.toFixed(2) + " " + fTError.toFixed(2) + " ");
		              Response.Write(strMpntRemark +  "<br>\n");		      
        		      
		              CMpntItem = restreeMpnt.getNext();
		            }
		          }
		        }
		      }
		      else
		        Response.Write("No calibration<br>");
		      
		      
		      Response.Write("<br>\n");
		    }
		    else
		    {
		      Response.Write("Disabled <br><br>\n");
		    }
		  }
			restree.setCurrent(CCaseItem);
			CCaseItem = restree.getNext();
		}
		
		return nCases;
}

function splitSearch( strTabStr, strLookFor )
{
  var str = new String(strTabStr);
  var arr = str.split("\t");
  
  for( var i = 0; i < arr.length; i++ ) 
  {
    if ( arr[i] == strLookFor )
       return i;
  }
  return -1;
}  

%>
